#include <dos.h>

/* Routines per la gestione del mouse */
/* By Fenoglio Elio */


        /* Inizializzazione */


#define ON  1
#define OFF 0     /* Costanti per un uso piu' elastico */


        /* Definizione procedure mouse */


/* Abilita/disabilita il mouse */
mouse_cursor_status(status)
unsigned char status;
{
        union REGS reg;
        reg.x.ax=2-status;
        int86(51,&reg,&reg);
        return 0;
}

/* Resetta il mouse e riporta tutti i valori in default */
mouse_reset()
{
        union REGS reg;
        reg.x.ax=0;
        int86(51,&reg,&reg);
        return(reg.x.ax);
}

/* Restituisce se il bottone  premuto (1: sinistro, 2: destro, 3: centrale, se esiste) */
unsigned char button_pressed(button)
unsigned char button;
{
        union REGS reg;
        reg.x.ax=3;
        int86(51,&reg,&reg);
        return((reg.x.bx&button)!=0);
}

/* Restituisce la coordinata X (orizzontale) del mouse espressa in pixel */
int mouse_x()
{
        union REGS reg;
        reg.x.ax=3;
        int86(51,&reg,&reg);
        return(reg.x.cx);
}

/* restituisce la coordinata Y (verticale) del mouse espressa in pixel */
int mouse_y()
{
        union REGS reg;
        reg.x.ax=3;
        int86(51,&reg,&reg);
        return(reg.x.dx);
}
/* Posiziona il mouse alle coordinate x,y espresse in pixel */
mouse_place(x,y)
int x,y;
{
        union REGS reg;
        reg.x.ax=4;
        reg.x.cx=x;
        reg.x.dx=y;
        int86(51,&reg,&reg);
        return 0;
}

/* Restituisce il numero di pressioni del bottone dall'ultima chiamata */
int number_presses(button)
int button;
{
        union REGS reg;
        reg.x.ax=5;
        reg.x.bx=button-1;
        int86(51,&reg,&reg);
        return(reg.x.bx);
}

/* Definisce il raggio di azione del mouse. Default: tutto schermo */
mouse_range(x0,y0,x1,y1)
int x0,y0,x1,y1;
{
        union REGS reg;
        reg.x.ax=7;
        reg.x.cx=x0;
        reg.x.dx=x1;
        int86(51,&reg,&reg);
        reg.x.ax=8;
        reg.x.cx=y0;
        reg.x.dx=y1;
        int86(51,&reg,&reg);
        return 0;
}
