/* PipBase.C main module for PipBase */

#define PROGRAM "PipBase"
#define PRGRM "PBse"

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>
#include <process.h>


#include "version.h"
#include "pipbase.h"

#define MAIN

#include "pipext.h"

#include "pb_proto.h"

void main(int argc,char *argv[])
{
  char ok=0,*a,mark=0; /* ok=0: not understood; ok=1: no parms; ok=2: OK */
  uint attr,area; NODEADDR dest;
  a=strupr(argv[1]);
  gettime(&tm); getdate(&dt);
  printf("PIPBASE - R.Piola, 1991 - %02d:%02d:%02d %02d.%02d.%04d\n",tm.ti_hour,tm.ti_min,tm.ti_sec,dt.da_day,dt.da_mon,dt.da_year);
  if (argc==1)
    {fprintf(stderr,"What do you want? Please run PIPBASE HELP for more informations.\7\n"); exit(1);}
  if(access("PipHelp.Ovr",0)||access("PipCfg.Ovr",0)) esci("Where are my overlay modules (*.OVR)?");
  if (!strcmp(a,"BOOST")) if (argc!=3) esci("usage: PIPBASE BOOST key|NULL"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"HELP")) {if(argc==2) execlp("PipHelp.Ovr","PipHelp.Ovr",NULL); else execlp("PipHelp.Ovr","PipHelp.Ovr",argv[2],NULL); exit(0);}
  if (!strcmp(a,"INFO")) {execlp("PipHelp.Ovr","PipHelp.Ovr","!!!INFO",NULL); ok=2;}
  if (!strcmp(a,"LISTAKAS")) {execlp("PipCfg.Ovr","PipCfg.Ovr",a,NULL); ok=2;}
  if (!strcmp(a,"LISTUSERS")) {execlp("PipCfg.Ovr","PipCfg.Ovr",a,NULL); ok=2;}
  if (!strcmp(a,"MANUAL")) {execlp("PipHelp.Ovr","PipHelp.Ovr","!!!MANUAL",NULL); ok=2;}
  if (!strcmp(a,"RESETELIM4D")) {execlp("PipCfg.Ovr","PipCfg.Ovr",a,NULL); ok=2;}
  if (!strcmp(a,"RESETROBOT")) if(argc!=3) esci("usage: PIPBASE RESETROBOT KILLREQUESTS|KILLANSWERS"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SET"))
    {
      if (argc!=5)
        esci("Usage: PIPBASE SET pipbase_dir logfile_name TINY|SMALL|MEDIUM|LARGE|EXTRA_LARGE");
      execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],argv[3],argv[4],NULL);
      read_cfg(1);
      openlog(); logg(' ',"PipBase system files created",0); closelog();
      exit(0);
    }
  if (!strcmp(a,"SETAREAFIX")) if(argc!=5) esci("usage: PIPBASE SETAREAFIX friend# password level#"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],argv[3],argv[4],NULL); ok=2;}
  if (!strcmp(a,"SETELIM4D")) {execlp("PipCfg.Ovr","PipCfg.Ovr",a,NULL); ok=2;}
  if (!strcmp(a,"SETFAKE")) if (argc!=3) esci("usage: PIPBASE SETFAKE fakenet"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETGHOST")) if(argc!=3) esci("usage: PIPBASE SETGHOST \"Ghostwriter's name\""); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETINBOUND")) if (argc!=3) esci("usage: PIPBASE SETINBOUND inbound_directory"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETLOGFILE")) if (argc!=3) esci("usage: PIPBASE SETLOGFILE logfile_name"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETLOGLEVEL")) if (argc!=3) esci("usage: PIPBASE SETLOGLEVEL 0|1|2|3"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETLOGTYPE")) if (argc!=3) esci("usage: PIPBASE SETLOGTYPE 0|1"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETNODE")) if (argc!=8) esci("usage: PIPBASE SETNODE aka# zone# net# node# point# domain"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],NULL); ok=2;}
  if (!strcmp(a,"SETOUTBOUND")) if (argc!=3) esci("usage: PIPBASE SETOUTBOUND outbound_directory"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETPACKERDIR")) if (argc!=3) esci("usage: PIPBASE SETPACKERDIR packer_directory"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETPIPDIR")) if (argc!=3) esci("usage: PIPBASE SETPIPDIR new_pipbase_directory"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETROBOT")) if(argc!=3) esci("usage: PIPBASE SETROBOT KILLREQUESTS|KILLANSWERS"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETRR")) if(argc!=3) esci("usage: PIPBASE SETRR return_receipt_file"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETTEMPDIR")) if (argc!=3) esci("usage: PIPBASE SETTEMPDIR temporary_directory"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],NULL); ok=2;}
  if (!strcmp(a,"SETUUCP")) if (argc!=8) esci("usage: PIPBASE SETUUCP outbound_zone net node inbound_zone net node"); else {execlp("PipCfg.Ovr","PipCfg.Ovr",a,argv[2],argv[3],argv[4],argv[5],argv[6],argv[7],NULL); ok=2;}
  if(ok!=2) read_cfg(1); /* reads general configuration values */
  if (*cfg.key) registered=verify_key(cfg.key,cfg.usernames[0],dt.da_day,dt.da_mon,dt.da_day,4);
  if (!strcmp(a,"ADDROUTE"))
    {
      if(argc<4)
        esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
      attr=atoi(argv[2]); 
      if ((attr<0) || (attr>255)) esci("Not a valid friend number");
      switch(toupper(*argv[3]))
        {
          case 'A':
            addroute(attr,0,0,0,0,ROUTE_ALL);
            break;
          case 'Z':
            if(argc!=5)
              esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
            else
              addroute(attr,atoi(argv[4]),0,0,0,ROUTE_ZONE);
            break;
          case 'R':
            if(argc!=6)
              esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
            else
              addroute(attr,atoi(argv[4]),atoi(argv[5]),0,0,ROUTE_REGION);
            break;
          case 'N':
            if(argc!=((toupper(argv[3][1])=='E')?6:7))
              esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
            else
              addroute(attr,atoi(argv[4]),atoi(argv[5]),(toupper(argv[3][1])=='E')?0:atoi(argv[6]),0,
                       (toupper(argv[3][1])=='E')?ROUTE_NET:ROUTE_NODE);
            break;
          case 'H':
            if(argc!=7)
              esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
            else
              addroute(attr,atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),0,ROUTE_REGION);
            break;
          case 'P':
            if(argc!=8)
              esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
            else
              addroute(attr,atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),atoi(argv[7]),ROUTE_POINT);
            break;
          default:
            esci("ADDROUTE friend# ALL|ZONE|NET|NODE|HUB|POINT [zone# [net# [node# [point#]]]]");
        }
      ok=2;
    }
  if (!strcmp(a,"DELROUTE")) if(argc!=3) esci("usage: PIPBASE DELROUTE rule#"); else {delroute(atoi(argv[2])); ok=2;}
  if (!strcmp(a,"LISTCFG")) {listcfg(); ok=2;}
  if (!strcmp(a,"LISTFRIENDS")) {listfriends(); ok=2;}
  if (!strcmp(a,"LISTROUTE")) {listroute(); ok=2;}
  if (!strcmp(a,"SETATTACHES")) if (argc<4) esci("usage: PIPBASE SETATTACHES netmail_*.msg_directory PIP!|FRODO|D'B|BINK|TRAPDOOR [PACK-MATRIX|DYNAMIC-PACKING]"); else {setattaches(argv[2],*argv[3],(argc==4)?NULL:argv[4]); ok=2;}
  if (!strcmp(a,"SETFRIEND")) if (argc<9) esci("usage: PIPBASE SETFRIEND friend# zone# net# node# point# packer \"packer_parameters\" [HOLD|CRASH]"); else {setfriend(atoi(argv[2]),atoi(argv[3]),atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),argv[7],argv[8],(argc==10)?strupr(argv[9]):""); ok=2;}
  if (!strcmp(a,"SETLASTREAD")) if (argc!=5) esci("usage: PIPBASE SETLASTREAD user# area# message#"); else {setlastread(atoi(argv[2]),atoi(argv[3]),atoi(argv[4]),0); ok=2;}
  if (!strcmp(a,"SETPACKER")) if (argc!=4) esci("usage: PIPBASE SETPACKER packer_program.ext \"parameters\""); else {setpacker(argv[2],argv[3]); ok=2;}
  if (!strcmp(a,"SETTEAR")) {if (argc<3) settear(""); else settear(argv[2]); ok=2;}
  if (!strcmp(a,"SETUNPACKER")) if (argc!=4) esci("usage: PIPBASE SETUNPACKER jolly_unpacker_program.ext \"parameters\""); else {setunpacker(argv[2],argv[3]); ok=2;}
  if (!strcmp(a,"SETUSER")) {if (argc!=4) esci("usage: PIPBASE SETUSER user# \"user name\"|NULL"); else {setuser(atoi(argv[2]),argv[3]); ok=2;}}
  if (!strcmp(a,"SHOWLASTREAD")) if (argc!=4) esci("usage: PIPBASE SHOWLASTREAD user# area#"); else {showlastread(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (ok!=2) read_cfg(2); /* reads origins */
  if (!strcmp(a,"LISTORIGINS")) {listorigins(); ok=2;}
  if (!strcmp(a,"SETORIGIN")) {if (argc!=4) esci("usage: PIPBASE SETORIGIN origin# \"origin text\"\nand... be original!\7\n"); else {setorigin(atoi(argv[2]),argv[3]); ok=2;}}
  if (ok!=2) read_cfg(3); /* reads areas definition */
  if (ok!=2) openlog();
  if (!strcmp(a,"AREAFIX")) {areafix(); ok=2;}
  if (!strcmp(a,"CREATE"))
    {
      if ((argc!=7) && (argc!=8)) esci("usage: PIPBASE CREATE area# \"description\" tagname|#LOCAL|#NETMAIL|#BAD|#DUPES message# day# [origin#]");
      if (argc==7) {if (*argv[4]!='#') esci("you must specify an origin# when you create an echomail area");  else argv[7]="0";}
      create_area(atoi(argv[2]),argv[3],argv[4],atoi(argv[5]),atoi(argv[6]),atoi(argv[7])); ok=2;
    }
  if (!strcmp(a,"DELETE")) if(argc!=4) esci("usage: PIPBASE DELETE area# message#"); else {msg_delete(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"DESTROY")) {if (*argv[2]==0) esci("usage: PIPBASE DESTROY area#"); else {destroy_area(atoi(argv[2])); ok=2;}}
  if (!strcmp(a,"EXPORT")) {export(); ok=2;}
  if (!strcmp(a,"GHOST")) {rr(1); ok=2;}
  if (!strcmp(a,"IMPORT")) {import(); ok=2;}
  if (!strcmp(a,"INDEX")) {if (argc==2) reindex(NULL); else reindex(argv[2]); ok=2;}
  if (!strcmp(a,"LISTAREA")) {if (argc<3) esci("usage: PIPBASE LISTAREA area# [NEW]"); else {listarea(atoi(argv[2]),(argc==3)?0:SET_NEW); ok=2;}}
  if (!strcmp(a,"LISTAREAS")) {listareas((stricmp(argv[2],"VERBOSE"))?0:1); ok=2;}
  if (!strcmp(a,"LISTEXPORT")) {listexport(); ok=2;}
  if (!strcmp(a,"LINK")) {if (argc==2) msg_link(NULL); else msg_link(argv[2]); ok=2;}
  if (!strcmp(a,"LOCK")) if(argc!=4) esci("usage: PIPBASE LOCK area# message#"); else {msg_lock(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"MARK")) if(argc!=4) esci("usage: PIPBASE MARK area# message#"); else {msg_mark(atoi(argv[2]),atoi(argv[3]),0); ok=2;}
  if (!strcmp(a,"MOVEAREA")) if(argc!=4) esci("usage: PIPBASE MOVEAREA oldarea# newarea#"); else {movearea(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"PACK")) {if (argc==2) msg_pack(NULL); else msg_pack(argv[2]); ok=2;}
  if (!strcmp(a,"PICKORIGIN")) {if (argc!=4) esci("usage: PIPBASE PICKORIGIN area# origin#"); else {pickorigin(atoi(argv[2]),atoi(argv[3])); ok=2;}}
  if (!strcmp(a,"POST"))
    {
      if (argc<7)
        esci("usage: PIPBASE POST area# filename \"from...\"|user# \"to...\"|user# \"subj\" [zone net node point [PRIVATE] [CRASH] [ATTACH] [REQUEST] [HOLD] [KILL] [RR] [AUDIT]]");
      else
        {
          attr=0;
          area=atoi(argv[2]);
          if (argc<11)
            {
              dest.zone=cfg.address[areas[area].address].zone;
              dest.net=cfg.address[areas[area].address].net;
              dest.node=cfg.address[areas[area].address].node;
              dest.point=cfg.address[areas[area].address].point;
            }
          else
            {
              if (stricmp(areas[area].tag,"#NETMAIL"))
                esci("Address and flags can be specified only in netmail areas");
              dest.zone=atoi(argv[7]);
              dest.net=atoi(argv[8]);
              dest.node=atoi(argv[9]);
              dest.point=atoi(argv[10]);
              for (mark=11; mark!=argc; mark++)
                switch(toupper(*argv[mark]))
                  {
                    case 'P': attr|=SET_PKT_PRIV; break;
                    case 'C': attr|=SET_PKT_CRASH; break;
                    case 'A':
                      attr|=(toupper(argv[mark][1])=='U')?SET_PKT_AUDIT:SET_PKT_ATTACH;
                      break;
                    case 'R': 
                      attr|=(toupper(argv[mark][1])=='R')?SET_PKT_RRRQ:SET_PKT_REQUEST;
                      break;
                    case 'H': attr|=SET_PKT_HOLD; break;
                    case 'K': attr|=SET_PKT_KILL; break;
                    default: esci("I cannot understand the switch!");
                  }
            }
          msg_post(area,argv[3],argv[4],argv[5],argv[6],attr,&dest,"");
          ok=2;
        }
    }
  if (!strcmp(a,"PURGE")) 
    {
      if (argc==2) 
        purge(NULL,1); /* neither area nor NOINDEX specified */
      else 
        {
          if(argc==3)
            {
              if(isdigit(*argv[2]))
                purge(argv[2],1); /* area */
              else
                purge(NULL,0); /* NOINDEX */
           }
         else
           purge(argv[2],0); /* area and NOINDEX */
        }
      ok=2;
    }
  if (!strcmp(a,"READ")) if (argc<4) esci("usage: PIPBASE READ area# message# [MARK|DELETE]"); else {msg_read(atoi(argv[2]),atoi(argv[3]),(argc>4)?(stricmp(argv[4],"DELETE")?SET_DEL:SET_MARK):0); ok=2;}
  if (!strcmp(a,"READAREA"))
    {
       mark=0;
       switch(argc)
         {
           case 5:
             if (!stricmp(argv[4],"NEW")) mark|=SET_NEW;
             if (!stricmp(argv[4],"MARK")) mark|=SET_MARK;
             if (!stricmp(argv[4],"DELETE")) mark|=SET_DEL;
           case 4:
             if (!stricmp(argv[3],"NEW")) mark|=SET_NEW;
             if (!stricmp(argv[3],"MARK")) mark|=SET_MARK;
             if (!stricmp(argv[3],"DELETE")) mark|=SET_DEL;
           case 3:
             msg_readarea(atoi(argv[2]),mark); ok=2;
             break;
           default:
             esci("usage: PIPBASE READAREA area# [MARK|DELETE] [NEW]"); break;
         }
    }
  if (!strcmp(a,"RESETEXPORT")) if(argc!=4) esci("usage: PIPBASE RESETEXPORT area# friend#"); else {resetexport(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"RR")) {rr(0); ok=2;}
  if (!strcmp(a,"SCANX")) if (argc<3) esci("usage: PIPBASE SCANX user# [area#]"); else {if (argv[3]) scanx(atoi(argv[2]),argv[3]); else scanx(atoi(argv[2]),NULL); ok=2;}
  if (!strcmp(a,"SETAREALEVEL")) if(argc!=4) esci("usage: PIPBASE SETAREALEVEL area# level#"); else {setarealevel(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"SETEXPORT")) if(argc!=4) esci("usage: PIPBASE SETEXPORT area# friend#"); else {setexport(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"SETPURGE")) if(argc<5) esci("usage: PIPBASE SETPURGE area# messages# days#"); else {setpurge(atoi(argv[2]),atoi(argv[3]),atoi(argv[4])); ok=2;}
  if (!strcmp(a,"SETTAG")) if(argc!=4) esci("usage: PIPBASE SETTAG area# tag"); else {settag(atoi(argv[2]),argv[3]); ok=2;}
  if (!strcmp(a,"STAT")) {base_stat(); ok=2;}
  if (!strcmp(a,"UNDELETE")) if(argc!=4) esci("usage: PIPBASE UNDELETE area# message#"); else {msg_undelete(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"UNLOCK")) if(argc!=4) esci("usage: PIPBASE UNLOCK area# message#"); else {msg_unlock(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!strcmp(a,"UNMARK")) if(argc!=4) esci("usage: PIPBASE UNMARK area# message#"); else {msg_unmark(atoi(argv[2]),atoi(argv[3])); ok=2;}
  if (!ok) {fprintf(stderr,"I can't make sense of the command %s you issued me\n(I beg pardon, but I'm so stupid, sometimes ;-)\n\7Please run PIPBASE HELP to have the command list\n",a);}
  free (areas);
  closelog();
  if (ok<2) exit(1);
}
