#include <stdlib.h>
#include <stdio.h>
#include <dos.h>
#include <string.h>
#include <dir.h>


#include "pipbase.h"

NODEINFO cfg;
FILE *f;
char fn[80];
char origins[256][60];


void dirset(char *dest,char *src)
{
  int i;
  struct ffblk blk;
  if ((i=strlen(src))>63)
    {fprintf(stderr,"Directory name \"%s\" is too long!\n\7",src); exit(2);}
  strcpy(dest,src); if (dest[i-1]!='\\') {dest[i]='\\'; dest[i+1]=0;}
  if(src[i-1]=='\\')
    src[i-1]=0;
  if(findfirst(src,&blk,FA_DIREC) && (strlen(src)>2))
    fprintf(stderr,"Warning: directory %s does not exist; please create it.\n",src);
  strupr(dest);
}


void setexfile(char *dest,char *src)
{
  if (strlen(src)>63)
    {fprintf(stderr,"File name \"%s\" is too long!\n\7",src); exit(2);}
  strcpy(dest,src);
  strupr(dest);
  if(access(dest,0))
    printf("Warning: file %s does not exist, create it!\n",dest);
}


void write_nodeinfo()
{
  f=fopen("NodeInfo.Cfg","rb+");
  if (f==NULL)
    f=fopen("NodeInfo.Cfg","wb");    
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create NodeInfo.Cfg file; please check...\7\n");
      exit(2);
    }
  printf("Writing NodeInfo.Cfg...\n");
  fwrite(&cfg,sizeof cfg,1,f);
  fclose(f);
}


void boost(char *s)
{
  if(!stricmp(s,"NULL"))
    {printf("Registration key removed: why did you do this?\n"); *cfg.key=0;}
  else
    {
      if(strlen(s)!=21)
        {fprintf(stderr,"This string cannot be a key! Retype correctly."); exit(2);}
      else
        sprintf(cfg.key,"%s",strupr(s));
      if(*cfg.usernames[0])
        printf("OK: You're on the right $-) side, now!...\n... and the Force is with you, enhancing PipBase\n");
      else
        puts("In order to make the key effective, you've only to set correctly the user#0\n");
    }
  write_nodeinfo();
}


void listakas()
{
  int i;
  printf("Addresses:\n");
  for (i=0; i!=10; i++)
    if (cfg.address[i].net || cfg.address[i].node)
      printf("%2d : %d:%d/%d.%d@%s\n",i,
              cfg.address[i].zone,
              cfg.address[i].net,
              cfg.address[i].node,
              cfg.address[i].point,
              cfg.address[i].domain);
  if (cfg.fakenet) printf("Fakenet: %d\n",cfg.fakenet); else puts("No fakenet used");
  if (cfg.use_uucp&SET_UUCP)
    {
      printf("UUCP Outbound Gateway: %d:%d/%d    Inbound: %d:%d/%d\n",
             cfg.uucp_out_zone,cfg.uucp_out_net,cfg.uucp_out_node,
             cfg.uucp_in_zone,cfg.uucp_in_net,cfg.uucp_in_node);
      puts((cfg.use_uucp&SET_UUCP_GHOST)?"Use ghostwriter also in Internet":"Do not use Ghostwriter in Internet");
    }
  else
    puts("No UUCP gateway defined");
}


void listusers()
{
  int i;
  printf("Users:\n");
  for (i=0; i!=8; i++) if (*cfg.usernames[i]) printf("%d : %s\n",i,cfg.usernames[i]);
}


void resetelim4d()
{
  cfg.compact&=RESET_COMPACT_REMOVE_4D;
  write_nodeinfo();
}


void resetrobot(char *a)
{
  cfg.compact&=(toupper(a[4])=='R')?RESET_COMPACT_KILLROBOTRQ:RESET_COMPACT_KILLROBOTASW;
  write_nodeinfo();
}


void set_all(char *pipdir,char *logfile,char *model)
{
  uint i;
  long j;
  AREASTRUCT area;
  switch(toupper(*model))
    {
      case 'T':
        cfg.pipsize=64;
        break;
      case 'S':
        cfg.pipsize=256;
        break;
      case 'M':
        cfg.pipsize=1024;
        break;
      case 'L':
        cfg.pipsize=4096;
        break;
      case 'E': 
      case 'X':
        cfg.pipsize=32768;
        break;
      default: 
        fprintf(stderr,"I'm sorry, but I understand only TINY, SMALL, MEDIUM, LARGE and EXTRA-LARGE sizes\7\n");
        exit(1);
    }
  dirset(cfg.pipdir,pipdir);
  strcpy(cfg.packer,"PKARC.COM"); strcpy(cfg.packerparms,"-a");
  strcpy(cfg.jolly,"GUS.EXE"); strcpy(cfg.jollyparms,"");
  if ((i=strlen(logfile))>63) {fprintf(stderr,"File name \"%s\" is too long!",logfile); exit(1);}
  strcpy(cfg.logfilename,logfile); cfg.loglevel=3; cfg.logtype=1;
  cfg.fakenet=0;
  for (i=0; i!=10; i++) cfg.address[i].zone=cfg.address[i].net=cfg.address[i].node=cfg.address[i].point=*cfg.address[i].domain=0;
  for (i=0; i!=8; i++) *cfg.usernames[i]=0;
  *cfg.attaches=*cfg.inbound=*cfg.outbound=*cfg.packerdir=cfg.compact=0;
  strcpy(cfg.addtear,"and nothing else");
  cfg.attachstyle=1; cfg.pack_matrix=0; /* !!!!!!!!!!!!!!!!!!!!!!!!! */
  if (getenv("TMP"))
    strcpy(cfg.tempdir,getenv("TMP"));
  else
    {
      if (getenv("TEMP"))
        strcpy(cfg.tempdir,getenv("TEMP"));
      else
        *cfg.tempdir=0;
    }
  cfg.use_uucp=0;
  write_nodeinfo();
  *area.descr=*area.tag=area.killrcv=area.readlevel=area.writelevel=area.origin=area.address=*area.note=0;
  for (i=0; i!=4; i++) area.readflags[i]=area.writeflags[i]=0;
  area.nrmsgs=200; area.days=30;
  sprintf(fn,"%sBaseDesc.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create the PipBase files; please check for %s\7\n",fn);
      exit(2);
    }
  printf("Creating %s...\n",fn);
  for (i=0; i!=cfg.pipsize; i++) fwrite(&area,sizeof(AREASTRUCT),1,f);
  fclose(f);
  for (i=3; i!=256; i++) *origins[i]=0;
  strcpy(origins[0],"**** INSTALLING PIPBASE ****");
  strcpy(origins[1],"Be smart, install PIPBase");
  strcpy(origins[2],"From Italy with love: PIPBase");
  sprintf(fn,"%sOrigins.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create the PipBase files; please check for %s\7\n",fn);
      exit(2);
    }
  printf("Creating %s...\n",fn);
  fwrite(origins,sizeof(origins),1,f); fclose(f);
  sprintf(fn,"%sDestPtr.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create the PipBase files; please check for %s\7\n",fn);
      exit(2);
    }
  printf("Creating %s...\n",fn);
  fclose(f);
  sprintf(fn,"%sFriendNd.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create the PipBase files; please check for %s\7\n",fn);
      exit(2);
    }
  printf("Creating %s...\n",fn);
  fclose(f);
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create the PipBase files; please check for %s\7\n",fn);
      exit(2);
    }
  printf("Creating %s...\n",fn);
  i=0;
  for(j=0; j!=8*cfg.pipsize; j++)
    fwrite(&i,sizeof i,1,f); fclose(f);
}


void setareafix(unsigned char n,char *password,unsigned char level)
{
  FRIENDND fri;
  uint i;
  if ((n<0) || (n>255)) {fprintf(stderr,"Not a valid friend number\7\n"); exit(2);}
  sprintf(fn,"%sFriendNd.Pip",cfg.pipdir); f=fopen(fn,"rb+");
  fseek(f,n*sizeof(fri),SEEK_SET);
  fread(&fri,sizeof(fri),1,f);
  strcpy(fri.areafix_pw,password);
  fri.areafix_lev=level;
  fseek(f,n*sizeof(fri),SEEK_SET);
  fwrite(&fri,sizeof(fri),1,f);
  fclose(f);
  printf("Now %d:%d/%d.%d is enable to Areafix with level %d and passowrd %s\n",fri.zone,fri.net,fri.node,fri.point,level,password);
}


void setelim4d()
{
  cfg.compact|=SET_COMPACT_REMOVE_4D;
  write_nodeinfo();
}


void setfake(int fakenet)
{
  cfg.fakenet=fakenet; printf("Fakenet set to %d\n",fakenet);
  write_nodeinfo();
}


void setghost(char *gn)
{
  if(strlen(gn)>34)
    {
      fprintf(stderr,"This name is too long to be a Ghostwriter's name.\7\n");
      fprintf(stderr,"The GhostWriter is not an Ent, nor it comes from Gaia.\n");
      exit(1);
    }
  strcpy(cfg.ghost,gn);
  write_nodeinfo();
}


void setinbound(char *new)
{
  int i;
  dirset(cfg.inbound,new);
  write_nodeinfo();
}


void setlogfile(char *new)
{
  if (strlen(new)>64) {fprintf(stderr,"pathname too long to be the logfile name\7\n"); exit(2);}
  strcpy(cfg.logfilename,new);
  write_nodeinfo();
}


void setloglevel(int l)
{
  cfg.loglevel=l;
  write_nodeinfo();
}


void setlogtype(int l)
{
  cfg.logtype=l;
  write_nodeinfo();
}


void setnode(int i,int z,int nt,int nd,int pt,char *dom)
{
  if ((i<0) || (i>9)) {fprintf(stderr,"Not a valid aka number (you can have only 10 akas)\7\n"); exit(2);}
  cfg.address[i].zone=z;
  cfg.address[i].net=nt;
  cfg.address[i].node=nd;
  cfg.address[i].point=pt;
  strcpy(cfg.address[i].domain,dom);
  write_nodeinfo();
}


void setoutbound(char *new)
{
  int i;
  dirset(cfg.outbound,new);
  write_nodeinfo();
}


void setpackerdir(char *new)
{
  int i;
  dirset(cfg.packerdir,new);
  write_nodeinfo();
}


void setpipdir(char *new)
{
  int i;
  printf("Make sure that all files in %s have been moved in %s\n",cfg.pipdir,new);
  dirset(cfg.pipdir,new);
  write_nodeinfo();
}


void setrobot(char *a)
{
  cfg.compact|=(toupper(a[4])=='R')?SET_COMPACT_KILLROBOTRQ:SET_COMPACT_KILLROBOTASW;
  write_nodeinfo();
}


void setrr(char *a)
{
  if(stricmp(a,"NULL"))
    setexfile(cfg.receipt,a);
  else
    *cfg.receipt=0;
  write_nodeinfo();
}


void settempdir(char *new)
{
  int i;
  dirset(cfg.tempdir,new);
  write_nodeinfo();
}


void setuucp(uint z1,uint n1,uint d1,uint z2,uint n2,uint d2)
{
  cfg.uucp_out_zone=z1;
  cfg.uucp_out_net=n1;
  cfg.uucp_out_node=d1;
  cfg.uucp_in_zone=z2;
  cfg.uucp_in_net=n2;
  cfg.uucp_in_node=d2;
  cfg.use_uucp=1;
  write_nodeinfo();
}



void main(int argc,char *argv[])
{
  char *a,*b;
  a=argv[1]; 
  if(argc>2) b=argv[2]; else b=NULL;
  if(!strcmp(a,"SET")) {set_all(b,argv[3],argv[4]); exit(0);}
  f=fopen("NodeInfo.Cfg","rb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot find NODEINFO.CFG file; please run PIPBASE SET ....\7\n");
      exit(2);
    }
  fread(&cfg,sizeof cfg,1,f);
  fclose(f);
  if(!strcmp(a,"BOOST")) boost(b);
  if(!strcmp(a,"LISTAKAS")) listakas();
  if(!strcmp(a,"LISTUSERS")) listusers();
  if(!strcmp(a,"RESETELIM4D")) resetelim4d();
  if(!strcmp(a,"RESETROBOT")) resetrobot(b);
  if(!strcmp(a,"SETAREAFIX")) setareafix(atoi(b),strupr(argv[3]),atoi(argv[4]));
  if(!strcmp(a,"SETELIM4D")) setelim4d();
  if(!strcmp(a,"SETFAKE")) setfake(atoi(b));
  if(!strcmp(a,"SETGHOST")) setghost(b);
  if(!strcmp(a,"SETINBOUND")) setinbound(b);
  if(!strcmp(a,"SETLOGFILE")) setlogfile(b);
  if(!strcmp(a,"SETLOGLEVEL")) setloglevel(atoi(b));
  if(!strcmp(a,"SETLOGTYPE")) setlogtype(atoi(b));
  if(!strcmp(a,"SETNODE")) setnode(atoi(b),atoi(argv[3]),atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),argv[7]);
  if(!strcmp(a,"SETOUTBOUND")) setoutbound(b);
  if(!strcmp(a,"SETPACKERDIR")) setpackerdir(b);
  if(!strcmp(a,"SETPIPDIR")) setpipdir(b);
  if(!strcmp(a,"SETROBOT")) setrobot(b);
  if(!strcmp(a,"SETRR")) setrr(b);
  if(!strcmp(a,"SETTEMPDIR")) settempdir(b);
  if(!strcmp(a,"SETUUCP")) setuucp(atoi(b),atoi(argv[3]),atoi(argv[4]),atoi(argv[5]),atoi(argv[6]),atoi(argv[7]));
}
