/* mail exporting procedures for PipBase */

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <errno.h>
#include <io.h>
#include <overlay.h>

#include "pipbase.h"

#include "pipext.h"

#include "version.h"

static char exported[32];
typedef struct {uint net,node,point;} AUDIT;
static uint hwm;
static unsigned long prevmsgid=0;
static char id[60],id2[60];


unsigned long unixdte()
{
  struct time t;
  struct date d;
  gettime(&t);
  getdate(&d);
  return ((absday(d.da_year,d.da_mon,d.da_day)-1)*86400+t.ti_hour*36000+t.ti_min*600+t.ti_sec*60+t.ti_hund/10);
}


char *msgid(uint z,uint net,uint node,uint point,char *domain) /* Thanks to Silvan Calarco */
{
  unsigned long newid;
  strcpy(id,"\1MSGID: ");
  if (point) sprintf(id2,"%d:%d/%d.%d",z,net,node,point); else sprintf(id2,"%d:%d/%d",z,net,node);
  strcat(id,id2);
  if (*domain) sprintf(id2,"@%s ",domain); else sprintf(id2," ");
  strcat(id,id2);
  newid=unixdte();
  if (newid<=prevmsgid) newid++;
  prevmsgid=newid;
  sprintf(id2,"%08lx",newid);
  strcat(id,id2);
  return id;
}


void set_hwm()
{
  char fn[80];
  struct ffblk blk;
  sprintf(fn,"%s*.msg",cfg.attaches);
  hwm=0;
  if (!findfirst(fn,&blk,0))
    do
      if (hwm<atoi(blk.ff_name)) hwm=atoi(blk.ff_name);
    while (!findnext(&blk));
}


int sort_seen_by(const void *e1,const void *e2)
{
  AUDIT *s1,*s2;
  s1=(AUDIT*)e1; s2=(AUDIT*)e2;
  if (s1->net>s2->net) return 1;
  if (s1->net<s2->net) return -1;
  if (s1->node>s2->node) return 1;
  if (s1->node<s2->node) return -1;
  if (s1->point>s2->point) return 1;
  if (s1->point<s2->point) return -1;
  return 0;
}


void isolate_path(char *buff,AUDIT seen_by[],AUDIT path[])
{
  int i,ns,np;
  char *p,*p2;
  uint t;
  memset(seen_by,0,512*sizeof(AUDIT));
  memset(path,0,128*sizeof(AUDIT));
  i=0;
  if ((p=strstr(buff,"\1PATH: "))!=NULL)
    {
      p2=p; *p=0; p+=7;
      while (p)
        {
          if (*p=='.')
            {
              if (i)
                {path[i].net=path[i-1].net; path[i].node=path[i-1].node;}
              else
                {path[i].net=cfg.address[0].net; path[i].node=cfg.address[0].node;}
              path[i].point=atoi(p+1);
            }
          else
            if (*p>32)
              {
                t=atoi(p); while (isdigit(*p)) p++;
                if (*p=='/')
                  {path[i].net=t; path[i].node=atoi(++p); while(isdigit(*p)) p++;}
                else
                  {path[i].net=path[i-1].net; path[i].node=t; while(isdigit(*p)) p++;}
                if (*p=='.')
                  path[i].point=atoi(p);
                else
                  path[i].point=0;
              }
          p=strchr(p,' '); if (p) p++;
          i++;
        }
    }
  np=i;
  i=0; ns=0;
  do
    p2-=82;
    while (((p=strstr(p2,"SEEN-BY: "))-p2<80) && p);
  if((p=strstr(p2,"SEEN-BY: "))!=NULL)
    {
      i=0;
      *p=0; p+=9;
      while (p)
        {
          if (*p=='.')
            {
              if (i)
                {seen_by[i].net=seen_by[i-1].net; seen_by[i].node=seen_by[i-1].node;}
              else
                {seen_by[i].net=cfg.address[0].net; seen_by[i].node=cfg.address[0].node;}
              seen_by[i].point=atoi(p+1);
              ns++; i++;
            }
          else
            if (*p>32)
              {
                t=atoi(p); while (isdigit(*p)) p++;
                if (*p=='/')
                  {seen_by[i].net=t; seen_by[i].node=atoi(++p); while(isdigit(*p)) p++;}
                else
                  {seen_by[i].net=seen_by[i-1].net; seen_by[i].node=t; while(isdigit(*p)) p++;}
                if (*p=='.')
                  seen_by[i].point=atoi(p);
                else
                  seen_by[i].point=0;
                ns++; i++;
              }
          p=strchr(p,' '); if (p) p++;
        }
    }
  if (not_in_seen_by(seen_by,cfg.address[0].net,cfg.address[0].node,cfg.address[0].point))
    {
      seen_by[ns].net=cfg.address[0].net;
      seen_by[ns].node=cfg.address[0].node;
      seen_by[ns].point=cfg.address[0].point;
      ns++;
    }
  path[np].net=cfg.address[0].net;
  path[np].node=cfg.address[0].node;
  path[np].point=cfg.address[0].point;
  np++;
}


int not_in_seen_by(AUDIT *seen_by,uint net,uint node,uint point)
{
  int i;
  for (i=0; i!=512; i++,seen_by++)
    if ((seen_by->net==net) && (seen_by->node==node) && (seen_by->point==point)) return 0;
  return -1;
}


void write_seen_by(AUDIT seen_by[],AUDIT path[],FILE *f)
{
  int i,c,ns;
  uint lastnet=0,lastnode=0;
  char add[20];
  AUDIT *s;
  for(i=0,ns=0; i!=512; i++)
    {
      if((seen_by[i].net || seen_by[i].node || seen_by[i].point))
        if (seen_by[i].net!=cfg.fakenet)
          {
            seen_by[ns].net=seen_by[i].net;
            seen_by[ns].node=seen_by[i].node;
            seen_by[ns].point=seen_by[i].point;
            ns++;
          }
    }
  for(i=ns; i!=512; i++)
    seen_by[i].net=seen_by[i].node=seen_by[i].point=0;
  c=0;
  qsort(seen_by,ns,sizeof(AUDIT),sort_seen_by);
  for (i=0; i!=ns; i++)
    if ((seen_by[i].net || seen_by[i].node || seen_by[i].point) &&
        !(seen_by[i].point && (cfg.compact & SET_COMPACT_REMOVE_4D)))
      {
        s=&seen_by[i];
        if (c==0) {fprintf(f,"SEEN-BY: "); c=8;}
        if (s->net==lastnet)
          {
            if (s->node==lastnode)
              sprintf(add,".%d",s->point);
            else
              {
                if (s->point)
                  sprintf(add,"%d.%d",s->node,s->point);
                else
                  sprintf(add,"%d",s->node);
              }
          }
        else                                
          {
            if (s->point)
              sprintf(add,"%d/%d.%d",s->net,s->node,s->point);
            else
              sprintf(add,"%d/%d",s->net,s->node);
          }
        lastnet=s->net;
        lastnode=s->node;
        c+=strlen(add);
        fprintf(f,"%s ",add);
        if (c>70) {fputc(13,f); c=lastnet=lastnode=0;}
      }
  fputc(13,f); c=lastnet=lastnode=0;
  for (i=0; i!=128; i++)
    if ((path[i].net || path[i].node || path[i].point) &&
        !(seen_by[i].point && (cfg.compact & SET_COMPACT_REMOVE_4D)))
      {
        s=&path[i];
        if (c==0) {fprintf(f,"\1PATH: "); c=5;}
        if (s->net==lastnet)
          {
            if (s->node==lastnode)
              sprintf(add,".%d",s->point);
            else
              {
                if (s->point)
                  sprintf(add,"%d.%d",s->node,s->point);
                else
                  sprintf(add,"%d",s->node);
              }
          }
        else
          {
            if (s->point)
              sprintf(add,"%d/%d.%d",s->net,s->node,s->point);
            else
              sprintf(add,"%d/%d",s->net,s->node);
          }
        lastnet=s->net;
        lastnode=s->node;
        c+=strlen(add);
        fprintf(f,"%s ",add);
        if (c>70) {fputc(13,f); c=lastnet=lastnode=0;}
      }
  fputc(13,f);
}


void open_packet(FILE *ff,int i,FILE **fo,uint area,FRIENDND *fri,MAILPKT *mailhdr)
{
  char bff2[80];
  fseek(ff,i*sizeof(FRIENDND),SEEK_SET); fread(fri,sizeof(FRIENDND),1,ff);
  sprintf(fn,"%sPKTOFR%02x.OUT",cfg.tempdir,i);
  if((*fo=fopen(fn,"rb+"))==NULL)
    {
      sprintf(bff2,"packet %s for ",fn);
      sprintf(lbuff,"%d",fri->zone); strcat(bff2,lbuff);
      sprintf(lbuff,"%s:%d/%d.%d",bff2,fri->net,fri->node,fri->point);
      printf("\nCreating %s\n",lbuff); logg('>',lbuff,1);
      *fo=fopen(fn,"wb");
      if(cfg.fakenet)
        {
          if(cfg.address[areas[area].address].point)
            {
              mailhdr->orig_node=cfg.address[areas[area].address].point;
              mailhdr->dest_node=fri->node;
              mailhdr->orig_net=cfg.fakenet;
              mailhdr->dest_net=fri->net;
            }
          else
            {
              if(fri->point)
                {
                  mailhdr->orig_node=cfg.address[areas[area].address].node;
                  mailhdr->dest_node=fri->point;
                  mailhdr->orig_net=cfg.address[areas[area].address].net;
                  mailhdr->dest_net=cfg.fakenet;
                }
              else
                {
                  mailhdr->orig_node=cfg.address[areas[area].address].node;
                  mailhdr->dest_node=fri->node;
                  mailhdr->orig_net=cfg.address[areas[area].address].net;
                  mailhdr->dest_net=fri->net;
                }
            }
        }
      else
        {
          mailhdr->orig_node=cfg.address[areas[area].address].node;
          mailhdr->dest_node=fri->node;
          mailhdr->orig_net=cfg.address[areas[area].address].net;
          mailhdr->dest_net=fri->net;
        }
      getdate(&dt); gettime(&tm);
      mailhdr->year=dt.da_year;
      mailhdr->month=dt.da_mon-1;
      mailhdr->day=dt.da_day;
      mailhdr->hour=tm.ti_hour;
      mailhdr->minute=tm.ti_min;
      mailhdr->second=tm.ti_sec;
      mailhdr->rate=0;
      mailhdr->ver=2;
      mailhdr->product=PRODUCT;
      mailhdr->rev_lev=10*PIPBASEVERSION+PIPBASESUBVERSION/10;
      memset(mailhdr->password,0,8);
      mailhdr->qm_orig_zone=mailhdr->orig_zone=cfg.address[areas[area].address].zone;
      mailhdr->qm_dest_zone=mailhdr->dest_zone=fri->zone;
      mailhdr->orig_point=mailhdr->wm_orig_point=cfg.address[areas[area].address].point;
      mailhdr->dest_point=mailhdr->wm_dest_point=fri->point;
      mailhdr->pr_data=registered;
      fwrite(mailhdr,sizeof(MAILPKT),1,*fo);
    }
  else
    {
      fseek(*fo,filelength(fileno(*fo))-2,SEEK_SET);
      printf("\n");
    } 
}


void genfileattach(char *fl,uint z,uint net,uint node,uint pt,uint priority,uint kill,uint request)
{
  FILE *fo;
  struct ffblk blk;
  FIDOMSG fidohdr;
  switch(cfg.attachstyle)
    {
      case 0: /*PIP!!!!!!!!!!!!!!!!! */
        break;
      case 1:
        sprintf(fn,"%s*.MSG",cfg.attaches);
        if(!findfirst(fn,&blk,0))
          do
            {
              sprintf(fn,"%s%s",cfg.attaches,blk.ff_name);
              fo=fopen(fn,"rb");
              fread(&fidohdr,sizeof fidohdr,1,fo);
              fclose(fo);
              if(!stricmp(fl,fidohdr.subj) &&
                 (fidohdr.attr&(request?((request==2)?SET_PKT_UPDATE:SET_PKT_REQUEST):SET_PKT_ATTACH)) &&
                 !(fidohdr.attr&SET_PKT_SENT)) return;
            } while (!findnext(&blk));
        hwm++;
        sprintf(fn,"%s%d.MSG",cfg.attaches,hwm);
        fo=fopen(fn,"wb");
        strcpy(fidohdr.fromwho,"ArcMail");
        strcpy(fidohdr.towho,"SysOp");
        strcpy(fidohdr.subj,fl);
        sprintf(fidohdr.date,"%02d %3s %02d  %02d:%02d:%02d",dt.da_day,mname[dt.da_mon-1],dt.da_year%100,tm.ti_hour,tm.ti_min,tm.ti_sec);
        fidohdr.times=1;
        fidohdr.orignode=cfg.address[0].node;
        fidohdr.destnode=node;
        fidohdr.cost=1;
        fidohdr.origzone=cfg.address[0].zone;
        fidohdr.destzone=z;
        fidohdr.orignet=cfg.address[0].net;
        fidohdr.destnet=net;
        fidohdr.origpoint=cfg.address[0].point;
        fidohdr.destpoint=pt;
        fidohdr.reply=fidohdr.nextreply=0;
        fidohdr.attr=(request?((request==2)?SET_PKT_UPDATE:SET_PKT_REQUEST):SET_PKT_ATTACH)|SET_PKT_KILL|((priority&FRI_SET_HOLD)?SET_PKT_HOLD:0)|((priority&FRI_SET_CRASH)?SET_PKT_CRASH:0)|SET_PKT_LOCAL;
        fwrite(&fidohdr,sizeof fidohdr,1,fo);
        if(pt) fprintf(fo,"\1TOPT %d\r",pt);
        if(cfg.address[0].point) fprintf(fo,"\1FMPT %d\r",cfg.address[0].point);
        if(kill) write0("\1FLAGS: KFS\r",fo); else write0("");
        fclose(fo);
        break;
      case 2: /* BINK */
        if(cfg.address[0].zone==z)
          strcpy(fidohdr.subj,cfg.outbound);
        else
          {
            sprintf(fidohdr.subj,"%s%03d\\",cfg.outbound,z);
            fidohdr.subj[strlen(cfg.outbound)-1]='.';
          }
        if(cfg.address[0].point && (net==cfg.address[0].net) && (node==cfg.address[0].node))
          {
            if(pt)
              sprintf(fn,"%04x%04x",cfg.fakenet,pt);
            else
              sprintf(fn,"%04x%04x",net,node);
          }
        else
          {
            if(pt && (net==cfg.address[0].net) && (node==cfg.address[0].node))
              sprintf(fn,"%04x%04x",cfg.fakenet,pt);
            else
              sprintf(fn,"%04x%04x",net,node);
          }
        strcat(fidohdr.subj,fn);
        if(priority & FRI_SET_HOLD)
          strcat(fidohdr.subj,".Hlo");
        else
          if(priority & FRI_SET_CRASH)
            strcat(fidohdr.subj,".Clo");
          else
            strcat(fidohdr.subj,".Flo");
        sprintf(fn,"%s%s",kill?"^":"",fl);
        if((f=fopen(fidohdr.subj,"rb+"))==NULL)
          {
            f=fopen(fidohdr.subj,"wb");
            if(!request) fprintf(f,"%s\n",fn);
            fclose(f);
          }
        else
          {
            char *s;
            if(!request)
              {
                while (!feof(f))
                  {
                    s=fidohdr.subj; memset(s,0,72);
                    while (((*s=fgetc(f))!='\n') && !feof(f)) s++;
                      if (strstr(fidohdr.subj,fn)) {fclose(f); return;}
                  }
                fseek(f,filelength(fileno(f)),SEEK_SET);
                fprintf(f,"%s\n",fn);
                fclose(f);
              }
            else
              fclose(f);
          }
        if(request)
          {
            sprintf(strchr(fidohdr.subj,'.'),(request==2)?".Upd":".Req");
            f=fopen(fidohdr.subj,"ab");
            fprintf(f,"%s\n",fl);
            fclose(f);
          }
        break;
    } 
}


int isouraka(uint zone,uint net,uint node,uint point)
{
  char k;
  for(k=0; k!=10; k++)
    if(((cfg.address[k].zone==zone) &&
        (cfg.address[k].net==net) &&
        (cfg.address[k].node==node) &&
        (cfg.address[k].point==point)) ||
       ((cfg.fakenet==net) &&
        (cfg.address[k].point==node)))
      return 1;
  return 0;
}


void export_area(uint area)
{
  FILE *fh,*fm,*fo,*ff;
  FRIENDND fri;
  long p;
  MSGPTR hdr;
  MSGPKTHDR mpkt,outpkt;
  MAILPKT mailhdr;
  char date[20],from[36],to[36],subj[72],*buff,toexport[32],*pt,bff2[120],mexmsgid[50],k;
  int tofr;
  uint i,ns,nm=0,frompoint,topoint,fromzone,tozone;
  AUDIT seen_by[512],path[128];
  FIDOMSG fidohdr;
  if ((buff=(char *)malloc(BUFSIZE))==NULL) esci("Not enought memory");
  sprintf(lbuff,"Scanning area %d...",area);
  printf(lbuff); logg(' ',lbuff,3);
  sprintf(fn,"%sMPTR%04x.Pip",cfg.pipdir,area); fh=fopen(fn,"rb+");
  sprintf(fn,"%sMPKT%04x.Pip",cfg.pipdir,area); fm=fopen(fn,"rb+");
  sprintf(fn,"%sFriendNd.Pip",cfg.pipdir); ff=fopen(fn,"rb");
  p=0;
  printf("      ");
  while(fread(&hdr,sizeof(hdr),1,fh))
    {
      printf("\b\b\b\b\b\b");
      printf("%05i ",nm); nm++;
      if(!(hdr.status&SET_MPTR_SENT) && !(hdr.status&SET_MPTR_DEL)) /* message not yet sent */
        {
          fseek(fm,hdr.pos,SEEK_SET); 
          fread(&mpkt,sizeof mpkt,1,fm);
          read0(date,fm,20,1);
          read0(to,fm,36,1);
          read0(from,fm,36,1);
          read0(subj,fm,72,1);
          switch(mpkt.pktype)
            {
              case 0:
              case 2:
                read0(buff,fm,BUFSIZE,1);
                break;
              case 10:
                unpipfile(buff,fm); 
                break;
              default: 
                free(buff); 
                sprintf(buff,"Unknown compression method (%d)!",mpkt.pktype);
                esci(buff); break;
            }
          if (*areas[area].tag!='#')
            {
              memset(path,0,sizeof(path));
              memset(seen_by,0,sizeof(seen_by));
              isolate_path(buff,seen_by,path);
              memset(toexport,0,32);
              ns=511;
              strcpy(mexmsgid,msgid(cfg.address[areas[area].address].zone,cfg.address[areas[area].address].net,cfg.address[areas[area].address].node,cfg.address[areas[area].address].point,cfg.address[areas[area].address].domain));
              for(i=0; i!=256; i++)
                if (isbit(i,areas[area].forward_to))
                  {
                    fseek(ff,i*sizeof(fri),SEEK_SET); fread(&fri,sizeof fri,1,ff);
                    if (not_in_seen_by(seen_by,fri.net,fri.node,fri.point))
                      {
                        seen_by[ns].net=fri.net;
                        seen_by[ns].node=fri.node;
                        seen_by[ns].point=fri.point;
                        setbit(i,toexport);
                        ns--;
                      }
                  }
              printf("\b*");
              for(i=0; i!=256; i++)
                if (isbit(i,toexport))
                  {
                    open_packet(ff,i,&fo,area,&fri,&mailhdr);
   /* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
                    sprintf(bff2,"msg %d exported to ",(p/sizeof hdr));
                    sprintf(lbuff,"%d",fri.zone); strcat(bff2,lbuff);
                    sprintf(lbuff,"%s:%d/%d.%d",bff2,fri.net,fri.node,fri.point);
                    printf("  %s\n",lbuff); logg(' ',lbuff,3);
                    memcpy(&outpkt,&mpkt,sizeof mpkt);
                    outpkt.attribute&=SEADOG_MASK&RESET_PKT_LOCAL;
                    outpkt.pktype=2; outpkt.point=0;
                    fwrite(&outpkt,sizeof outpkt,1,fo);
                    write0(date,fo); write0(to,fo); write0(from,fo); write0(subj,fo);
                    fprintf(fo,"AREA:%s\r",areas[area].tag);
                    if (!strstr(buff,"\1MSGID"))
                      fprintf(fo,"%s\r",mexmsgid);
                    if ((hdr.status&SET_MPTR_FROMUS) && cfg.address[areas[area].address].point && (!strstr(buff,"\1FMPT")) && (*areas[area].tag=='#')) /* here Kurgan signaled a bad ; */
                      fprintf(fo,"\1FMPT %d\r",cfg.address[areas[area].address].point);
                    fwrite(buff,strlen(buff),1,fo);
                    write_seen_by(seen_by,path,fo);
                    fputc(0,fo);
                    fputc(0,fo); fputc(0,fo); fclose(fo);
                    setbit(i,exported);
                  }
            }
          else
            {
              if (!strcmp(areas[area].tag,"#NETMAIL"))
                {
                  frompoint=topoint=0;
                  fromzone=tozone=cfg.address[areas[area].address].zone;
                  if ((pt=strstr(buff,"\1FMPT "))!=NULL)
                    frompoint=atoi(pt+6);
                  if(!frompoint && (mpkt.attribute&SET_PKT_LOCAL) && mpkt.point) frompoint=mpkt.point;
                  if ((pt=strstr(buff,"\1TOPT "))!=NULL)
                    topoint=atoi(pt+6);
                  if ((pt=strstr(buff,"\1INTL "))!=NULL)
                    {tozone=atoi(pt+6); fromzone=atoi(strstr(pt," ")+1);}
                  if(!isouraka(tozone,mpkt.tonet,mpkt.tonode,topoint))
                    {
                      /* put ^aVia kludge */
                      if((k=buff[strlen(buff)-1])!=13 && k!=10)
                        strcat(buff,"\r");
                      if(registered)
                        sprintf(bff2,"%d",registered);
                      else
                        strcpy(bff2,"demo");
                      getdate(&dt); gettime(&tm);
                      sprintf(lbuff,"\1Via node %d:%d/%d.%d%s%s, %2d %s %4d  %2d:%02d:%02d, PipBase %d.%02d/%s\r",
                                    cfg.address[areas[area].address].zone,
                                    cfg.address[areas[area].address].net,
                                    cfg.address[areas[area].address].node,
                                    cfg.address[areas[area].address].point,
                                    *cfg.address[areas[area].address].domain?"@":"",
                                    cfg.address[areas[area].address].domain,
                                    dt.da_day,mname[dt.da_mon-1],dt.da_year,
                                    tm.ti_hour,tm.ti_min,tm.ti_sec,
                                    PIPBASEVERSION,PIPBASESUBVERSION,bff2);
                      strcat(buff,lbuff);
                      if((cfg.pack_matrix==0) || 
                         ((cfg.attachstyle==1) && 
                          ((mpkt.attribute&SET_PKT_CRASH) || 
                           (mpkt.attribute&SET_PKT_HOLD) ||
                           (mpkt.attribute&SET_PKT_REQUEST) || 
                           (mpkt.attribute&SET_PKT_UPDATE) ||
                           (mpkt.attribute&SET_PKT_ATTACH))))
                        {
                          hwm++;
                          sprintf(lbuff,"Message %d exported as netmail %d.MSG",nm,hwm);
                          logg(' ',lbuff,3); puts(lbuff);
                          sprintf(fn,"%s%d.MSG",cfg.attaches,hwm);
                          if((fo=fopen(fn,"wb"))==NULL)
                            esci("I cannot export it!");
                          strcpy(fidohdr.fromwho,from);
                          strcpy(fidohdr.towho,to);
                          strcpy(fidohdr.subj,subj);
                          strcpy(fidohdr.date,date);
                          fidohdr.times=1;
                          fidohdr.orignode=mpkt.fromnode;
                          fidohdr.destnode=mpkt.tonode;
                          fidohdr.cost=1;
                          fidohdr.origzone=fromzone;
                          fidohdr.destzone=tozone;
                          fidohdr.orignet=mpkt.fromnet;
                          fidohdr.destnet=mpkt.tonet;
                          fidohdr.origpoint=frompoint;
                          fidohdr.destpoint=topoint;
                          fidohdr.reply=fidohdr.nextreply=0;
                          fidohdr.attr=mpkt.attribute|SET_PKT_KILL;
                          fwrite(&fidohdr,sizeof fidohdr,1,fo);
                          if((mpkt.attribute&SET_PKT_LOCAL) && cfg.address[areas[area].address].point && !strstr(buff,"\1FMPT"))
                            fprintf(fo,"\1FMPT %d\r",cfg.address[areas[area].address].point);
                          write0(buff,fo);
                          fclose(fo);
                        }
                      else
                        { /* pack matrix not in FD mode */
                          switch(cfg.attachstyle)
                            {
                              case 1:
                                printf("Message is from %d:%d/%d.%d to %d:%d/%d.%d\n",fromzone,mpkt.fromnet,mpkt.fromnode,frompoint,tozone,mpkt.tonet,mpkt.tonode,topoint);
                                if((tofr=route_to(tozone,mpkt.tonet,mpkt.tonode,topoint,areas[area].address))==-1)
                                  esci("It's impossible to route this, aborting");
                                fseek(ff,tofr*sizeof(fri),SEEK_SET);
                                fread(&fri,sizeof fri,1,ff);
                                sprintf(lbuff,"Message for %d:%d/%d.%d routed via %d:%d/%d.%d (%d)",tozone,mpkt.tonet,mpkt.tonode,topoint,fri.zone,fri.net,fri.node,fri.point,tofr);
                                logg(' ',lbuff,3); puts(lbuff);
                                open_packet(ff,tofr,&fo,area,&fri,&mailhdr);
                                memcpy(&outpkt,&mpkt,sizeof mpkt);
                                outpkt.attribute&=SEADOG_MASK&RESET_PKT_LOCAL;
                                outpkt.pktype=2; outpkt.point=0;
                                fwrite(&outpkt,sizeof outpkt,1,fo);
                                write0(date,fo); write0(to,fo); write0(from,fo); write0(subj,fo);
                                strcpy(mexmsgid,msgid(cfg.address[areas[area].address].zone,cfg.address[areas[area].address].net,cfg.address[areas[area].address].node,cfg.address[areas[area].address].point,cfg.address[areas[area].address].domain));
                                if (!strstr(buff,"\1MSGID"))
                                  fprintf(fo,"%s\r",mexmsgid);
                                if ((hdr.status&SET_MPTR_FROMUS) && cfg.address[areas[area].address].point && (!strstr(buff,"\1FMPT")) && (*areas[area].tag=='#')) /* here Kurgan signaled a bad ; */
                                  fprintf(fo,"\1FMPT %d\r",cfg.address[areas[area].address].point);
                                fwrite(buff,strlen(buff),1,fo);
                                fputc(0,fo);
                                fputc(0,fo); fputc(0,fo); fclose(fo);
                                setbit(tofr,exported); /* this goes in case 2: */
                                break;
                              case 2: /* Binkley */
                                if(mpkt.attribute&SET_PKT_ATTACH)
                                  genfileattach(subj,tozone,mpkt.tonet,mpkt.tonode,topoint,
                                                (mpkt.attribute&SET_PKT_HOLD)?FRI_SET_HOLD:0|
                                                (mpkt.attribute&SET_PKT_CRASH)?FRI_SET_CRASH:0,
                                                0,0);
                                if(mpkt.attribute&SET_PKT_REQUEST)
                                  genfileattach(subj,tozone,mpkt.tonet,mpkt.tonode,topoint,
                                                (mpkt.attribute&SET_PKT_HOLD)?FRI_SET_HOLD:0|
                                                (mpkt.attribute&SET_PKT_CRASH)?FRI_SET_CRASH:0,
                                                0,1);
                                if(mpkt.attribute&SET_PKT_UPDATE)
                                  genfileattach(subj,tozone,mpkt.tonet,mpkt.tonode,topoint,
                                                (mpkt.attribute&SET_PKT_HOLD)?FRI_SET_HOLD:0|
                                                (mpkt.attribute&SET_PKT_CRASH)?FRI_SET_CRASH:0,
                                                0,2);
                                if(((tofr=route_to(tozone,mpkt.tonet,mpkt.tonode,topoint,areas[area].address))==-1) ||
                                   (mpkt.attribute&SET_PKT_CRASH) || (mpkt.attribute&SET_PKT_HOLD))
                                  {
                                    if(cfg.address[0].zone==tozone)
                                      strcpy(fidohdr.subj,cfg.outbound);
                                    else
                                      {
                                        sprintf(fidohdr.subj,"%s%03d\\",cfg.outbound,tozone);
                                        fidohdr.subj[strlen(cfg.outbound)-1]='.';
                                      }
                                    if(cfg.address[0].point && (mpkt.tonet==cfg.address[0].net) && (mpkt.tonode==cfg.address[0].node))
                                      {
                                        if(pt)
                                          sprintf(fn,"%04x%04x",cfg.fakenet,pt);
                                        else
                                          sprintf(fn,"%04x%04x",mpkt.tonet,mpkt.tonode);
                                      }
                                    else
                                      {
                                        if(pt && (mpkt.tonet==cfg.address[0].net) && (mpkt.tonode==cfg.address[0].node))
                                          sprintf(fn,"%04x%04x",cfg.fakenet,pt);
                                        else
                                          sprintf(fn,"%04x%04x",mpkt.tonet,mpkt.tonode);
                                      }
                                    strcat(fidohdr.subj,fn);
                                    if(mpkt.attribute & SET_PKT_HOLD)
                                      strcat(fidohdr.subj,".Hut");
                                    else
                                      if(mpkt.attribute & SET_PKT_CRASH)
                                        strcat(fidohdr.subj,".Cut");
                                      else
                                        strcat(fidohdr.subj,".Out");
                                    if((fo=fopen(fidohdr.subj,"rb+"))==NULL)
                                      {
                                        sprintf(bff2,"packet %s for ",fidohdr.subj);
                                        sprintf(lbuff,"%d",tozone); strcat(bff2,lbuff);
                                        sprintf(lbuff,"%s:%d/%d.%d",bff2,mpkt.tonet,mpkt.tonode,topoint);
                                        printf("\nCreating %s\n",lbuff); logg('>',lbuff,1);
                                        fo=fopen(fidohdr.subj,"wb");
                                        if(cfg.fakenet)
                                          {
                                            if(cfg.address[areas[area].address].point)
                                              {
                                                mailhdr.orig_node=cfg.address[areas[area].address].point;
                                                mailhdr.dest_node=mpkt.tonode;
                                                mailhdr.orig_net=cfg.fakenet;
                                                mailhdr.dest_net=mpkt.tonet;
                                              }
                                            else
                                              {
                                                if(topoint)
                                                  {
                                                    mailhdr.orig_node=cfg.address[areas[area].address].node;
                                                    mailhdr.dest_node=topoint;
                                                    mailhdr.orig_net=cfg.address[areas[area].address].net;
                                                    mailhdr.dest_net=cfg.fakenet;
                                                  }
                                                else
                                                  {
                                                    mailhdr.orig_node=cfg.address[areas[area].address].node;
                                                    mailhdr.dest_node=mpkt.tonode;
                                                    mailhdr.orig_net=cfg.address[areas[area].address].net;
                                                    mailhdr.dest_net=mpkt.tonet;
                                                  }
                                              }
                                          }
                                        else
                                          {
                                            mailhdr.orig_node=cfg.address[areas[area].address].node;
                                            mailhdr.dest_node=mpkt.tonode;
                                            mailhdr.orig_net=cfg.address[areas[area].address].net;
                                            mailhdr.dest_net=mpkt.tonet;
                                          }
                                        getdate(&dt); gettime(&tm);
                                        mailhdr.year=dt.da_year;
                                        mailhdr.month=dt.da_mon-1;
                                        mailhdr.day=dt.da_day;
                                        mailhdr.hour=tm.ti_hour;
                                        mailhdr.minute=tm.ti_min;
                                        mailhdr.second=tm.ti_sec;
                                        mailhdr.rate=0;
                                        mailhdr.ver=2;
                                        mailhdr.product=PRODUCT;
                                        mailhdr.rev_lev=10*PIPBASEVERSION+PIPBASESUBVERSION/10;
                                        memset(mailhdr.password,0,8);
                                        mailhdr.qm_orig_zone=mailhdr.orig_zone=cfg.address[areas[area].address].zone;
                                        mailhdr.qm_dest_zone=mailhdr.dest_zone=tozone;
                                        mailhdr.orig_point=mailhdr.wm_orig_point=cfg.address[areas[area].address].point;
                                        mailhdr.dest_point=mailhdr.wm_dest_point=topoint;
                                        mailhdr.pr_data=registered;
                                        fwrite(&mailhdr,sizeof(MAILPKT),1,fo);
                                      }
                                    else
                                      {
                                        fseek(fo,filelength(fileno(fo))-2,SEEK_SET);
                                        printf("\n");
                                      } 
                                    sprintf(lbuff,"Message for %d:%d/%d.%d sent directly",tozone,mpkt.tonet,mpkt.tonode,topoint);
                                    logg(' ',lbuff,3); puts(lbuff);
                                    memcpy(&outpkt,&mpkt,sizeof mpkt);
                                    outpkt.attribute&=SEADOG_MASK&RESET_PKT_LOCAL;
                                    outpkt.pktype=2; outpkt.point=0;
                                    fwrite(&outpkt,sizeof outpkt,1,fo);
                                    write0(date,fo); write0(to,fo); write0(from,fo); write0(subj,fo);
                                    strcpy(mexmsgid,msgid(cfg.address[areas[area].address].zone,cfg.address[areas[area].address].net,cfg.address[areas[area].address].node,cfg.address[areas[area].address].point,cfg.address[areas[area].address].domain));
                                    if (!strstr(buff,"\1MSGID"))
                                      fprintf(fo,"%s\r",mexmsgid);
                                    if ((hdr.status&SET_MPTR_FROMUS) && cfg.address[areas[area].address].point && (!strstr(buff,"\1FMPT")) && (*areas[area].tag=='#')) /* here Kurgan signaled a bad ; */
                                      fprintf(fo,"\1FMPT %d\r",cfg.address[areas[area].address].point);
                                    fwrite(buff,strlen(buff),1,fo);
                                    fputc(0,fo);
                                    fputc(0,fo); fputc(0,fo); fclose(fo);
                                  }
                                else
                                  {
                                    printf("Message is from %d:%d/%d.%d to %d:%d/%d.%d\n",fromzone,mpkt.fromnet,mpkt.fromnode,frompoint,tozone,mpkt.tonet,mpkt.tonode,topoint);
                                    if((tofr=route_to(tozone,mpkt.tonet,mpkt.tonode,topoint,areas[area].address))==-1)
                                      esci("It's impossible to route this, aborting");
                                    fseek(ff,tofr*sizeof(fri),SEEK_SET);
                                    fread(&fri,sizeof fri,1,ff);
                                    sprintf(lbuff,"Message for %d:%d/%d.%d routed via %d:%d/%d.%d (%d)",tozone,mpkt.tonet,mpkt.tonode,topoint,fri.zone,fri.net,fri.node,fri.point,tofr);
                                    logg(' ',lbuff,3); puts(lbuff);
                                    open_packet(ff,tofr,&fo,area,&fri,&mailhdr);
                                    memcpy(&outpkt,&mpkt,sizeof mpkt);
                                    outpkt.attribute&=SEADOG_MASK&RESET_PKT_LOCAL;
                                    outpkt.pktype=2; outpkt.point=0;
                                    fwrite(&outpkt,sizeof outpkt,1,fo);
                                    write0(date,fo); write0(to,fo); write0(from,fo); write0(subj,fo);
                                    strcpy(mexmsgid,msgid(cfg.address[areas[area].address].zone,cfg.address[areas[area].address].net,cfg.address[areas[area].address].node,cfg.address[areas[area].address].point,cfg.address[areas[area].address].domain));
                                    if (!strstr(buff,"\1MSGID"))
                                      fprintf(fo,"%s\r",mexmsgid);
                                    if ((hdr.status&SET_MPTR_FROMUS) && cfg.address[areas[area].address].point && (!strstr(buff,"\1FMPT")) && (*areas[area].tag=='#')) /* here Kurgan signaled a bad ; */
                                      fprintf(fo,"\1FMPT %d\r",cfg.address[areas[area].address].point);
                                    fwrite(buff,strlen(buff),1,fo);
                                    fputc(0,fo);
                                    fputc(0,fo); fputc(0,fo); fclose(fo);
                                    setbit(tofr,exported);
                                  }
                                break;
                              default:
                                esci("Fileattach option not yet implemented!");
                            }
                        }
                      if (mpkt.attribute&SET_PKT_KILL) hdr.status|=SET_MPTR_DEL;
                    }
                }
              else
                logg(' ',"Local message, skipped",3);
            }
          hdr.status=hdr.status|SET_MPTR_SENT|((areas[area].nrmsgs)?0:SET_MPTR_DEL);
          mpkt.attribute=mpkt.attribute|SET_PKT_SENT;
          fseek(fh,p,SEEK_SET); fwrite(&hdr,sizeof hdr,1,fh);
          fseek(fm,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof mpkt,1,fm);
        }
      p=ftell(fh); fseek(fh,p,SEEK_SET);
    }
  fclose(fh); fclose(fm); fclose(ff);
  printf("\n");
  free(buff);
}


void pack_exported(uint i)
{
  FRIENDND fri;
  char command[128];
  char arcmailname[80],pktname[80];
  char *daynames[7]={"Su","Mo","Tu","We","Th","Fr","Sa"},day;
  day=1; /*(absday(dt.da_year,dt.da_mon,dt.da_day)-4)%7; for Qmail-style attaches*/
  sprintf(fn,"%sFriendNd.Pip",cfg.pipdir); f=fopen(fn,"rb");
  printf("Packing mail for friend#%d...\n",i);
  fseek(f,i*sizeof fri,SEEK_SET); fread(&fri,sizeof fri,1,f);
  sprintf(fn,"%sPKTOFR%02x.OUT",cfg.tempdir,i);
  sprintf(pktname,"%s%08lx.PKT",cfg.tempdir,unixdte());
  rename(fn,pktname);
  if ((cfg.address[0].net==fri.net) && (cfg.address[0].node==fri.node))
    sprintf(arcmailname,"%sP000%04x.%s1",cfg.outbound,cfg.address[0].point-fri.point,daynames[day]);
  else
    sprintf(arcmailname,"%s%04x%04x.%s1",cfg.outbound,cfg.address[0].net-fri.net,cfg.address[0].node-fri.node,daynames[day]);
  sprintf(lbuff,"Exported %s for %d:%d/%d.%d",arcmailname,fri.zone,fri.net,fri.node,fri.point);
  logg('#',lbuff,1);
  sprintf(command,"%s%s %s %s %s %s",cfg.packerdir,fri.packer,fri.packerparms,fri.pack_pw,arcmailname,pktname);
  printf("Calling %s\n",command);
  if (!overlay(command,0,"","",-1))
    {
      printf("OK: unlinking %s\n",pktname); unlink(pktname);
      genfileattach(arcmailname,fri.zone,fri.net,fri.node,fri.point,fri.flags&(FRI_SET_HOLD|FRI_SET_CRASH),1,0);
    }
  else
    {
      logg('!',"Overlay manager error",0);
      puts("WARNING:/7 Overlay manager error - falling back to non-swapping mode");
      if(!system(command))
        {
          printf("OK: unlinking %s\n",pktname); unlink(pktname);
          genfileattach(arcmailname,fri.zone,fri.net,fri.node,fri.point,fri.flags&(FRI_SET_HOLD|FRI_SET_CRASH),1,0);
        }
      else
        esci("FATAL: I cannot run packer!");
    }
  fclose(f);
}


void export()
{
  uint i;
  logg('>',"Exporting mail",1);
  kill_orphan_bundles(cfg.outbound,cfg.attaches,cfg.attachstyle!=1);
  set_hwm();
  for(i=0; i!=32; i++) exported[i]=0;
  for(i=0; i!=cfg.pipsize; i++)
    if (*areas[i].tag) export_area(i);
  for(i=0; i!=256; i++)
    if(isbit(i,exported)) pack_exported(i); 
}


int find_friend(uint zone,uint net,uint node,uint point,FRIENDND *fri)
{
  char fn[80];
  FILE *f;
  int rt;
  sprintf(fn,"%sFriendNd.Pip",cfg.pipdir);
  if ((f=fopen(fn,"rb"))==NULL)
    {sprintf(lbuff,"%d:%d/%d.%d is not a friend",zone,net,node,point); esci(lbuff);}
  rt=0;
  while (fread(fri,sizeof(FRIENDND),1,f))
    {
      if((fri->zone==zone) && (fri->net==net) && (fri->node==node) && (fri->point==point))
        {fclose(f); return rt;}
      rt++;
    }
  fclose(f); return -1;
}


int route_to(uint zone,uint net,uint node,uint point,char addr)
{
  ROUTE rt;
  FRIENDND fri;
  int l=-1,fr=-1;
  sprintf(fn,"%sRoute.Pip",cfg.pipdir);
  if((f=fopen(fn,"rb"))!=NULL)
    {
      while(fread(&rt,sizeof rt,1,f))
        switch(rt.mode)
          {
            case ROUTE_ALL:
              if(l<ROUTE_ALL) {l=ROUTE_ALL; fr=rt.via;}
              break;
            case ROUTE_ZONE:
              if((l<ROUTE_ZONE) && (zone==rt.zone))
                {l=ROUTE_ZONE; fr=rt.via;}
              break;
            case ROUTE_REGION:
              if((l<ROUTE_REGION) && (zone==rt.zone) && (floor(net/10)==rt.net))
                {l=ROUTE_REGION; fr=rt.via;}
              break;
            case ROUTE_NET:
              if((l<ROUTE_NET) && (zone==rt.zone) && (net==rt.net))
                {l=ROUTE_NET; fr=rt.via;}
              break;
           case ROUTE_HUB:
             if((l<ROUTE_HUB) && (zone==rt.zone) && (net==rt.net) && (floor(node/10)*10==rt.node))
               {l=ROUTE_HUB; fr=rt.via;}
             break;
           case ROUTE_NODE:
             if((l<ROUTE_NODE) && (zone==rt.zone) && (net==rt.net) && (node==rt.node))
               {l=ROUTE_NODE; fr=rt.via;}
             break;
            case ROUTE_POINT:
              if((l<ROUTE_POINT) && (zone==rt.zone) && (net==rt.net) && (node==rt.node) && (point==rt.point))
                {l=ROUTE_POINT; fr=rt.via;}
              break;
          }
      fclose(f);
    }
  if(l==-1) /* use default route */
    {
      if(cfg.address[addr].point)
        {
          fr=find_friend(cfg.address[addr].zone,cfg.address[addr].net,cfg.address[addr].node,0,&fri);
          if (fr==-1)
            {
              sprintf(lbuff,"You must define your boss %d:%d/%d.0 between your friends!",cfg.address[addr].zone,cfg.address[addr].net,cfg.address[addr].node);
              esci(lbuff);
            }
        }
      else
        {
          if((cfg.address[addr].zone==zone) && (cfg.address[addr].net==net) && (cfg.address[addr].node==node))
            { /* it's one of our points */
              fr=find_friend(zone,net,node,point,&fri);
              if (fr==-1)
                {
                  sprintf(lbuff,"You must define your point %d:%d/%d.%d between your friends!",zone,net,node,point);
                  esci(lbuff);
                }
            } 
          else
            {
              /* In future, only for registered version, default route */
              esci("You must define a route; I dont't know how to use a default route");
            } 
        }
    }
  return fr;
}


