/* mail importing procedures for PipBase */

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <dir.h>
#include <process.h>
#include <errno.h>
#include <io.h>
#include <overlay.h>

#include "pipbase.h"

#include "pipext.h"

#include "version.h"

static char exported[32];
typedef struct {uint net,node,point;} AUDIT;
static uint hwm;
static unsigned long prevmsgid=0;
static char id[60],id2[60];


char *identifypacker(char *packetname,char *parms,char *comdline) /* Thanks to Silvan Calarco */
{
  FILE *f;
  char buff[20];
  unsigned char headstr[8];
  f=fopen(packetname,"rb");
  strcpy(comdline,"PKXARC.COM"); strcpy(parms,"-r");
  if (fread(headstr,7,1,f))
    {
      if ((headstr[2]=='-') && (headstr[3]=='l'))
        switch(headstr[4])
          {
            case 'h':
              sprintf(comdline,"%sLHA.EXE",cfg.packerdir); 
              if (!access(comdline,0) || (headstr[5]>'1'))
                strcpy(comdline,"LHA.EXE");
              else
                strcpy(comdline,"LHARC.EXE");
              strcpy(parms,"x /cm"); 
              break;
            case 'z': 
              strcpy(comdline,"LHA.EXE"); strcpy(parms,"x /cm"); break;
            default: esci("Unknown compression method for ArcMail!");
          }
      else
        switch(*headstr)
          {
            case 26:
              {strcpy(comdline,"PAK.EXE"); strcpy(parms,"E /WA");}
              if ((headstr[1]<10) || (headstr[1]>12))
                {
                  sprintf(buff,"PKXARC.COM");
                  if (access(buff,0)) 
                    {strcpy(comdline,"PKXARC.COM"); strcpy(parms,"-r");}
                  sprintf(buff,"PKUNPAK.EXE");
                  if (access(buff,0))
                    {strcpy(comdline,"PKUNPAK.EXE"); strcpy(parms,"-r");}
                }
              break;
            case 'P':
              if ((headstr[1]==75) /*&& (headstr[2]==3) && (headstr[3]==4)*/)
                {strcpy(comdline,"PKUNZIP.EXE"); strcpy(parms,"-o -ed");}
              break;
            case 'Z':
              if ((headstr[1]=='O') && (headstr[2]=='O'))
                {
                  strcpy(comdline,"ZOO.EXE");
                  strcpy(parms,"E");
                  break;
                }
            case 96:
              if (headstr[1]==234)
                {
                  strcpy(comdline,"ARJ.EXE");
                  strcpy(parms,"e -y");
                  break;
                }
            default:
              strcpy(comdline,cfg.jolly); strcpy(parms,cfg.jollyparms);
              break;
          }
    }
  fclose(f);
}


unpack_arcmail(char *dir,char *name)
{
  char cfn[80],cmdline[40],command[72],pktype[15];
  sprintf(cfn,"%s%s",dir,name);
  printf("Unpacking %s\n",cfn);
  identifypacker(cfn,cmdline,pktype);
  printf("Unpacker to use is %s %s\n",pktype,cmdline);
  sprintf(command,"%s%s %s %s",cfg.packerdir,pktype,cmdline,cfn);
  printf("Calling %s\n",command);
  if (overlay(command,0,"","",-1))
    {
      logg('!',"Overlay manager error",0);
      puts("WARNING:/7 Overlay manager error - falling back to non-swapping mode");
      if(system(command))
        {printf("OK: unlinking %s\n",cfn); unlink(cfn);}
        esci("FATAL: I cannot run unpacker!");
    }
}


import_pkt(char *dir,char *fname,char far*buff)
{
  char fnm[80],from[36],to[36],date[20],subj[72],are[30],*b2,*a,pktname[64],oldare[30];
  FILE *fi,*fo1=NULL,*fo2=NULL,*fo3;
  MAILPKT pkthdr;
  MSGPKTHDR mpkt;
  MSGPTR hdr;
  DESTPTR pt;
  uint areanum,oldarea=0xffff,msgcount=0;
  long p;
  *oldare=0;
  sprintf(pktname,"%s%s",dir,fname);
  if((fi=fopen(pktname,"rb"))==NULL)
    {
      fprintf(stderr,"I cannot open packet %s\n",pktname);
      return;
    }
  fread(&pkthdr,sizeof pkthdr,1,fi);
  if (pkthdr.day==0)
    sprintf(lbuff,"Importing packet %s, coming from a D'Bug :-( at %d:%d/%d.%d...",
     fname,pkthdr.orig_zone,pkthdr.orig_net,pkthdr.orig_node,pkthdr.orig_point);
  else
    sprintf(lbuff,"Importing packet %s, dated %02d.%02d.%d %02d:%02d:%02d, coming from %d:%d/%d.%d...",
     fname,pkthdr.day,pkthdr.month,pkthdr.year,pkthdr.hour,pkthdr.minute,pkthdr.second,pkthdr.orig_zone,pkthdr.orig_net,pkthdr.orig_node,pkthdr.orig_point);
  logg('#',lbuff,2);
  puts(lbuff);
  sprintf(subj,"%sDestPtr.Pip",cfg.pipdir);
  fo3=fopen(subj,"ab");
  while(fread(&mpkt,sizeof mpkt,1,fi))
    {
      p=ftell(fi);
      if(mpkt.pktype!=2)
        {
          logg('!',"Bad packet :-( Trying to save messages",0);
          puts("Warning: Bad packet, trying to save messages");
          p-=sizeof(mpkt);
          while(mpkt.pktype!=2)
            {
              fseek(fi,++p,SEEK_SET);
              fread(&mpkt,sizeof mpkt,1,fi);
            }
        }
      read0(date,fi,20,1);
      read0(to,fi,36,1);
      read0(from,fi,36,1);
      read0(subj,fi,72,1);
      read0(buff,fi,BUFSIZE-100,1);
      b2=buff;
      if (!strnicmp(buff,"AREA:",5))
        {
          a=are;
          b2=buff+5;
          while ((((*b2)&127)!=13) && *b2) *(a++)=*(b2++);
          *a=0; if ((*(a-1)&127)==13) *(a-1)=0;
          if (*b2==13) b2++;
          if (*b2==10) b2++;
        }
      else
        strcpy(are,"#NETMAIL");
      for (areanum=0; areanum!=cfg.pipsize; areanum++)
        if (!stricmp(are,areas[areanum].tag)) break;
      if(areanum==cfg.pipsize)
        {
          b2=buff;
          for (areanum=0; areanum!=cfg.pipsize; areanum++)
            if (!stricmp(areas[areanum].tag,"#BAD")) break;
        }
      if(areanum==cfg.pipsize)
        {
          sprintf(lbuff,"Bad area %s - skipped",are);
          puts(lbuff); logg('!',lbuff,0);
        }
      else
        {
          if(areanum!=oldarea)
            {
              if(fo2)
                {
                   fputc(0,fo2);
                   fputc(0,fo2);
                   fclose(fo1);
                   fclose(fo2);
                   sprintf(lbuff,"Tossed %d message%s in area %s (%d)",msgcount,(msgcount==1)?"":"s",oldare,oldarea);
                   puts(lbuff);
                   logg('#',lbuff,1);
                 }
              sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,areanum);
              fo1=fopen(fn,"rb+");
              if (fo1==NULL)
                fo1=fopen(fn,"wb");
              else
                fseek(fo1,filelength(fileno(fo1)),SEEK_SET);
              sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,areanum);
              fo2=fopen(fn,"rb+");
              if (fo2==NULL)
                fo2=fopen(fn,"wb");
              else
                fseek(fo2,filelength(fileno(fo2))-2,SEEK_SET);
              oldarea=areanum;
              strcpy(oldare,are);
              msgcount=0;
            }
          hdr.pos=ftell(fo2);
          hdr.prev=hdr.next=0; hdr.status=0;
          strcpy(pt.to,to);
          pt.next=0;
          pt.area=areanum;
          pt.msg=ftell(fo1)/sizeof(hdr);
          fwrite(&hdr,sizeof hdr,1,fo1);
          mpkt.pktype=10;
          mpkt.attribute&=RESET_PKT_LOCAL; /* to us */
          mpkt.point=pkthdr.orig_point;
          fwrite(&mpkt,sizeof mpkt,1,fo2);
          write0(date,fo2);
          write0(to,fo2);
          write0(from,fo2);
          write0(subj,fo2);
          pipstring(b2,fo2);
          fwrite(&pt,sizeof pt,1,fo3);
          msgcount++;
        }
    }
  sprintf(lbuff,"Tossed %d messages in area %s (%d)",msgcount,are,areanum);
  puts(lbuff);
  logg('#',lbuff,1);
  if (fclose(fo1)) esci("Error writing the PipBase!");
  fputc(0,fo2); fputc(0,fo2);
  if (fclose(fo2)) esci("Error writing the PipBase!");
  if (fclose(fo3)) esci("Error writing the PipBase!");
  fclose(fi); unlink(pktname);
}


void import_netmail(char far*buff) /* used with Front Door/D'Bridge */
{
  char fnm[64],are[30],*a;
  FILE *fi,*fo1,*fo2,*fo3;
  MSGPKTHDR mpkt;
  MSGPTR hdr;
  DESTPTR pt;
  FIDOMSG fidohdr;
  uint areanum,topt,tozone;
  struct ffblk blk;
  sprintf(fnm,"%sDestPtr.Pip",cfg.pipdir); fo3=fopen(fnm,"ab");
  sprintf(fn,"%s*.MSG",cfg.attaches);
  strcpy(are,"#NETMAIL");
  for (areanum=0; areanum!=cfg.pipsize; areanum++)
    if (!stricmp(are,areas[areanum].tag)) break;
  if(areanum==cfg.pipsize) return; /* there is no netmail area.... */
  if(!findfirst(fn,&blk,0))
    do
      {
        sprintf(fnm,"%s%s",cfg.attaches,blk.ff_name);
        fi=fopen(fnm,"rb");
        fread(&fidohdr,sizeof fidohdr,1,fi);
        read0(buff,fi,BUFSIZE,1);
        fclose(fi);
        if(a=strstr(buff,"\1TOPT "))
          topt=atoi(a+6);
        else
          topt=0;
        if(a=strstr(buff,"\1INTL "))
          tozone=atoi(strstr(a+6," ")+1);
        else
          tozone=cfg.address[areas[areanum].address].zone;
        if((tozone==cfg.address[areas[areanum].address].zone) &&
           (fidohdr.destnet==cfg.address[areas[areanum].address].net) &&
           (fidohdr.destnode==cfg.address[areas[areanum].address].node) &&
           (topt==cfg.address[areas[areanum].address].point))
          {
            sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,areanum); fo1=fopen(fn,"rb+");
            if (fo1==NULL) fo1=fopen(fn,"wb");
            sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,areanum); fo2=fopen(fn,"rb+");
            if (fo2==NULL) fo2=fopen(fn,"wb");
            hdr.pos=filelength(fileno(fo2))-2; fseek(fo2,hdr.pos,SEEK_SET);
            hdr.prev=hdr.next=0; hdr.status=0; fseek(fo1,filelength(fileno(fo1)),SEEK_SET);
            strcpy(pt.to,fidohdr.towho); 
            pt.next=0; pt.area=areanum; pt.msg=ftell(fo1)/sizeof(hdr);
            fwrite(&hdr,sizeof hdr,1,fo1);
            mpkt.pktype=10;
            mpkt.fromnode=fidohdr.orignode;
            mpkt.fromnet=fidohdr.orignet;
            mpkt.tonode=fidohdr.destnode;
            mpkt.tonet=fidohdr.destnet;
            mpkt.attribute=fidohdr.attr&RESET_PKT_LOCAL; /* to us */
            if(a=strstr(buff,"\1FMPT ")) mpkt.point=atoi(a+6); else mpkt.point=fidohdr.origpoint;
            fwrite(&mpkt,sizeof mpkt,1,fo2);
            write0(fidohdr.date,fo2); write0(fidohdr.towho,fo2); write0(fidohdr.fromwho,fo2); write0(fidohdr.subj,fo2);
            pipstring(buff,fo2);
            fputc(0,fo2); fputc(0,fo2);
            fwrite(&pt,sizeof pt,1,fo3);
            printf("Imported %s in #NETMAIL area\n",fnm);
            if (fclose(fo1)) esci("Error writing the PipBase!");
            if (fclose(fo2)) esci("Error writing the PipBase!");
            if(unlink(fnm)) esci("Cannot remove imported messages from Netmail area");
          }
      } while (!findnext(&blk));
  if (fclose(fo3)) esci("Error writing the PipBase!");
}


import()
{
  struct ffblk blk,blk2;
  char fn[80],*s,*s1,far *buff,cfn[80];
  kill_orphan_bundles(cfg.outbound,cfg.attaches,cfg.attachstyle!=1);
  if ((buff=(char *)malloc(BUFSIZE))==NULL) esci("Not enought memory");
  puts("Importing mail...\n");
  sprintf(fn,"%s*.pkt",cfg.inbound);
  if (!findfirst(fn,&blk,0))
    do import_pkt(cfg.inbound,blk.ff_name,buff); while (!findnext(&blk));
  strcpy(fn,"*.pkt");
  if (!findfirst(fn,&blk,0))
    do import_pkt("",blk.ff_name,buff); while (!findnext(&blk));
  sprintf(fn,"%s*.*",cfg.inbound);
  if (!findfirst(fn,&blk,0))
    do 
      {
        if(isbundle(blk.ff_name))
          {
            unpack_arcmail(cfg.inbound,blk.ff_name);
            if (findfirst("*.pkt",&blk2,0))
              {
                sprintf(lbuff,"I failed to unpack %s",blk.ff_name);
                logg('!',lbuff,0);
                puts(lbuff); putch(7);
              }
            else
              {
                sprintf(cfn,"%s%s",cfg.inbound,blk.ff_name);
                printf("OK: unlinking %s\n",cfn); unlink(cfn);
                do import_pkt("",blk2.ff_name,buff); while (!findnext(&blk2));
              }
          }
      }
    while (!findnext(&blk));
  printf("End of inbound packets.\n");
  import_netmail(buff);
  free(buff);
  printf("End of netmail.\n");
}




