/* PipManut.C procedures to do some maintenance */

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <dir.h>
#include <io.h>


#include "pipbase.h"

#include "pipext.h"

typedef struct {
              uint number,subject;
              } mxhead;

#include "pb_proto.h"

unsigned absday(int year,int month,int day)
{
  int minit[12]={0,31,59,90,120,151,181,212,243,273,304,334};
  int t;
  t=365*(year-1970)+(year-1970)/4+minit[month-1]+day;
  if ((month>2) && ((year&3)==0)) t++;
  return t;
}


unsigned mexdate(char *dta)
{
  struct date d;
  int i;
  char month[6];
  sscanf(dta,"%d %s %d",&d.da_day,month,&d.da_year);
  d.da_mon=1;
  for (i=0; i!=12; i++) if (!stricmp(month,mname[i])) d.da_mon=i+1;
  return absday(d.da_year+1900,d.da_mon,d.da_day);
}


void purge_area(uint a)
{
  unsigned today;
  uint l=0,d=0;
  char date[72],fni[80];
  long p;
  FILE *fi;
  MSGPTR hdr;
  today=absday(dt.da_year,dt.da_mon,dt.da_day);
  if(!*areas[a].tag)
    esci("You cannot purge an unexisting area!");
  printf("Purging area %d by date...",a);
  sprintf(fni,"%sMPTR%04x.PIP",cfg.pipdir,a); fi=fopen(fni,"rb+");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,a); f=fopen(fn,"rb");
  p=0;
  while(fread(&hdr,sizeof hdr,1,fi))
    {
      l++;
      fseek(f,hdr.pos+14,SEEK_SET); read0(date,f,20,1);
      if (((abs(today-mexdate(date))>=areas[a].days) || 
           (areas[a].killrcv && (hdr.status&SET_MPTR_RCVD))) && 
          !(hdr.status&SET_MPTR_LOCK))
        {
          hdr.status|=SET_MPTR_DEL; 
          d++;
          fseek(fi,p,SEEK_SET);
          fwrite(&hdr,sizeof hdr,1,fi);
          fseek(fi,ftell(fi),SEEK_SET);
        }
      p=ftell(fi);
    }
  fclose(f);
  if(l-d>areas[a].nrmsgs)
    {
      printf("\rPurging area %d by number...",a);
      fseek(fi,p=0,SEEK_SET);
      while(fread(&hdr,sizeof hdr,1,fi))
        {
          if ((l-d>areas[a].nrmsgs) && !(hdr.status&SET_MPTR_LOCK) && !(hdr.status&SET_MPTR_DEL))
            {
               hdr.status|=SET_MPTR_DEL; 
               d++;
               fseek(fi,p,SEEK_SET);
               fwrite(&hdr,sizeof hdr,1,fi);
               fseek(fi,ftell(fi),SEEK_SET);
             }
           p=ftell(fi);
        }
    }
  fclose(fi);
  printf("%d/%d deleted...OK\n",d,l);
  sprintf(lbuff,"Area %d: %d/%d purged",a,d,l); logg('#',lbuff,1);
}


void purge(char *area,char index)
{
  unsigned int i;
  if (!area)
    {
      for(i=0; i!=cfg.pipsize; i++)
        if (*areas[i].descr)
          purge_area(i);
    }
  else
    purge_area(atoi(area));
  if(index) 
    {
      puts("Rebuilding DestPtr.Pip");
      rebuild_destptr(1);
    }
}


void reindex_area(uint a)
{
  FILE *fi,*fo;
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  uint j;
  if(!*areas[a].tag)
    esci("You cannot index an unexisting area!");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,a);
  if((fi=fopen(fn,"rb"))==NULL)
    {
      fi=fopen(fn,"wb"); 
      fputc(0,fi);
      fputc(0,fi);
      fclose(fi);
      fi=fopen(fn,"rb"); 
    }
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,a);
  sprintf(lbuff,"Rebuilding MPTR%04x.PIP for area #%d",a,a);
  logg(' ',lbuff,2); puts(lbuff);
  fo=fopen(fn,"wb");
  hdr.pos=0;
  while(fread(&mpkt,sizeof mpkt,1,fi))
    {
      hdr.prev=hdr.next=0;
      hdr.status=0;
      if(mpkt.attribute&SET_PKT_SENT) hdr.status|=SET_MPTR_SENT;
      if(mpkt.attribute&SET_PKT_RCVD) hdr.status|=SET_MPTR_RCVD;
      if(mpkt.attribute&SET_PKT_LOCAL) hdr.status|=SET_MPTR_FROMUS;
      for(j=0; j!=5; j++)
        while(fgetc(fi) && !feof(fi));
      hdr.pos=ftell(fi);
    }
  fclose(fi);
  fclose(fo);
  link_area(a);
}


void reindex(char *area)
{
  unsigned int i;
  if (!area)
    {
      for(i=0; i!=cfg.pipsize; i++)
        if (*areas[i].descr)
          reindex_area(i);
    }
  else
    if(isdigit(*area))
      reindex_area(atoi(area));
  puts("Warning: Delete and Lock flags are lost!");
  rebuild_destptr(0);
}


void pack_area(unsigned int a,char *buff)
{
  FILE *fi1,*fi2,*fo1,*fo2;
  char fni1[80],fni2[80],fno1[80],fno2[80];
  char date[20],from[36],to[36],subj[72];
  unsigned int l=0,s=0,lastread,lr,nu;
  MSGPTR hdr; MSGPKTHDR mpkt;
  if(!*areas[a].tag)
    esci("You cannot pack an unexisting area!");
  printf("Packing area %d... ",a);
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir); f=fopen(fn,"rb+");
  if(f==NULL) printf("\n\7Cannot open LastRead.Pip\n");
  nu=filelength(fileno(f))/(cfg.pipsize*sizeof(lastread));
  sprintf(fni1,"%sMPTR%04x.PIP",cfg.pipdir,a); fi1=fopen(fni1,"rb");
  sprintf(fni2,"%sMPKT%04x.PIP",cfg.pipdir,a); fi2=fopen(fni2,"rb");
  if((fi1==NULL) && (fi2==NULL))
    {
      sprintf(lbuff,"Missed files for area %d; creating....",a);
      logg('!',lbuff,0); puts(lbuff);
      fclose(f);
      fi1=fopen(fni1,"wb"); fclose(fi1);
      fi2=fopen(fni2,"wb"); fputc(0,fi2); fputc(0,fi2); fclose(fi2);
      return;
    }
  sprintf(fno1,"%sMPTR%04x.PI2",cfg.pipdir,a); fo1=fopen(fno1,"wb");
  sprintf(fno2,"%sMPKT%04x.PI2",cfg.pipdir,a); fo2=fopen(fno2,"wb");
  if((fo1==NULL) || (fo2==NULL))
    {
      printf("%s and %s\n",fno1,fno2);
      esci("Cannot open temporary files!");
    }
  while (fread(&hdr,sizeof hdr,1,fi1))
    {
      if (!(hdr.status&SET_MPTR_DEL))
        {
          fseek(fi2,hdr.pos,SEEK_SET);
          fread(&mpkt,sizeof mpkt,1,fi2);
          read0(date,fi2,20,1);
          read0(to,fi2,36,1);
          read0(from,fi2,36,1);
          read0(subj,fi2,72,1);
          read0(buff,fi2,BUFSIZE-100,1);
          for(lr=0; lr!=nu; lr++)
            {
              fseek(f,(lr*cfg.pipsize+a)*sizeof(lastread),SEEK_SET);
              fread(&lastread,sizeof lastread,1,f);
              if(lastread==l)
                {
                  fseek(f,(lr*cfg.pipsize+a)*sizeof(lastread),SEEK_SET);
                  fwrite(&s,sizeof lastread,1,f);
                }
            }
          s++;
          hdr.pos=ftell(fo2);
          fwrite(&hdr,sizeof hdr,1,fo1);
          fwrite(&mpkt,sizeof mpkt,1,fo2);
          write0(date,fo2);
          write0(to,fo2);
          write0(from,fo2);
          write0(subj,fo2);
          write0(buff,fo2);
        }
      l++;
      printf("%05d/%05d\b\b\b\b\b\b\b\b\b\b\b",s,l);
    }
  for(lr=0; lr!=nu; lr++)
    {
      fseek(f,(lr*cfg.pipsize+a)*sizeof(lastread),SEEK_SET);
      fread(&lastread,sizeof lastread,1,f);
      if(lastread>=s)
        {
          fseek(f,(lr*cfg.pipsize+a)*sizeof(lastread),SEEK_SET);
          lastread=(s>0)?(s-1):0;
          fwrite(&lastread,sizeof lastread,1,f);
        }
    } 
  printf("%05d/%05d copied... OK\n",s,l);
  fputc(0,fo2); fputc(0,fo2);
  if(fclose(f) || fclose(fi1) || fclose(fi2) || fclose(fo1) || fclose(fo2))
    printf("\n\7Cannot close files!\n");
  if (unlink(fni1)) printf("\n\7Cannot delete old file %s!\n",fni1);
  if (rename(fno1,fni1)) printf("\n\7Cannot rename new file %s!\n",fno1);
  if (unlink(fni2)) printf("\n\7Cannot delete old file %s!\n",fni2);
  if (rename(fno2,fni2)) printf("\n\7Cannot rename new file %s!\n",fno2);
}


void msg_pack(char *area)
{
  unsigned int i;
  char *buff;
  if ((buff=(char *)malloc(BUFSIZE))==NULL) esci("Not enought memory");
  if (!area)
    {
      for(i=0; i!=cfg.pipsize; i++)
        if (*areas[i].descr)
          {
            pack_area(i,buff);
            link_area(i);
          }
    }
  else
    {
      pack_area(atoi(area),buff);
      link_area(atoi(area));
    }
  free(buff);
  puts("Rebuilding DestPtr.Pip");
  rebuild_destptr(1);
}


int sum(char *s)
{
  int t;
  for (t=0; *s; s++) t+=*s;
  return t;
}


char *remove_reply(char *s)
{
  while(strstr(s,"Re:")||strstr(s,"re:")||strstr(s,"RE:")||strstr(s,"R:"))
    {
      if(strstr(s,"Re:")) s=strstr(s,"Re:")+3;
      if(strstr(s,"re:")) s=strstr(s,"re:")+3;
      if(strstr(s,"RE:")) s=strstr(s,"RE:")+3;
      if(strstr(s,"R:")) s=strstr(s,"R:")+2;
    }
  while (*s==' ') s++;
  return s;
}


int bysogg(const void *e1,const void *e2)
{
  if (*((int*)e1+1)!=*((int*)e2+1))
    return *((int*)e1+1)-*((int*)e2+1);
  else
    return *(int*)e1-*(int*)e2;
} /* costricted to this for @#?"##s of TC++ */


void link_area(uint area)
{
  uint totmsg,mex=0,q,ou,or;
  mxhead *msg;
  FILE *fh,*fm;
  MSGPTR hdr;
  char subj[72];
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); fh=fopen(fn,"rb+");
  totmsg=filelength(fileno(fh))/sizeof(MSGPTR);
  printf("Reading subjects...");
  if (!totmsg) {puts(""); fclose(fh); return;}
  if((msg=malloc(totmsg*sizeof(mxhead)))==NULL)
    {
      sprintf(lbuff,"Not enought memory to relink area %d",area);
      logg('!',lbuff,0);
      fclose(fh);
      return;
    }
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); fm=fopen(fn,"rb");
  while(fread(&hdr,sizeof hdr,1,fh))
    {
      fseek(fm,hdr.pos+14,SEEK_SET);
      read0(subj,fm,72,1);
      read0(subj,fm,72,1);
      read0(subj,fm,72,1);
      read0(subj,fm,72,1);
      msg[mex].number=mex; msg[mex].subject=sum(remove_reply(subj));
      mex++;
    }
  printf("Linking...");
  qsort((void*)msg,totmsg,sizeof(mxhead),bysogg);
  printf("Writing...");
  for(q=0; q!=totmsg; q++)
    {
      fseek(fh,msg[q].number*sizeof(hdr),SEEK_SET);
      fread(&hdr,sizeof hdr,1,fh);
      or=hdr.prev; ou=hdr.next;
      if((q==0) || msg[q].subject!=msg[q-1].subject)
        hdr.prev=0;
      else
        hdr.prev=msg[q-1].number;
      if((q==totmsg-1) || msg[q].subject!=msg[q+1].subject)
        hdr.next=0;
      else
        hdr.next=msg[q+1].number;
      if((ou!=hdr.next) || (or!=hdr.prev))
        {
          fseek(fh,msg[q].number*sizeof(hdr),SEEK_SET);
          fwrite(&hdr,sizeof hdr,1,fh);
        }
    }
  puts("Done!");
  fclose(fh); fclose(fm); free(msg);
}


void msg_link(char *area)
{
  unsigned int i;
  if (!area)
    {
      for(i=0; i!=cfg.pipsize; i++)
        if (*areas[i].descr)
          {
            printf("Area %d: ",i);
            link_area(i);
          }
    }
  else
    link_area(atoi(area));
}



void base_stat()
{
  unsigned int i,n=0,k;
  long tt=0;
  for(i=0; i!=cfg.pipsize; i++)
    if (*areas[i].descr)
      {
        k=number_of_messages(i);
        printf("Area %d contains %d messages\n",i,k);
        n++; tt+=k;
        fclose(f);
      }
  printf("Total: %ld messages in %d areas\n",tt,n);
}
