/* PipMsg.C procedures to handle basic message handling */

#include <stdio.h>
#include <alloc.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <ctype.h>
#include <io.h>
#include <fcntl.h>


#include "pipbase.h"

#undef MAIN

#include "pipext.h"
#include "version.h"

extern char *mname[12]; /*!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*/


create_area(int i,char *descr,char *tag,uint mex,uint days,unsigned char origin)
{
  int j;
  uint nu,lr;
  if ((i<0) || (i>=cfg.pipsize))
    {fprintf(stderr,"%d is not a valid area number"); esci("");}
  if (*areas[i].descr)
    esci("You cannot create an existing area");
  if (strlen(tag)>29)
    esci("tag too long");
  if (strlen(descr)>39)
    esci("description too long");
  if ((origin<0) || (origin>255))
    esci("not a valid origin number");
  strupr(tag);
  strcpy(areas[i].descr,descr);
  strcpy(areas[i].tag,tag); strupr(areas[i].tag);
  areas[i].nrmsgs=mex; 
  areas[i].days=days; 
  areas[i].origin=origin;
  areas[i].killrcv=*areas[i].note=areas[i].address=0;
  areas[i].readlevel=areas[i].writelevel=0;
  for(j=0; j!=32; j++)
    areas[i].forward_to[j]=0;
  for(j=0; j!=3; j++)
    areas[i].writeflags[j]=areas[i].readflags[j]=0;
  write_areas();
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,i);
  f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create PipBase file %s\n",fn); 
      esci("Please check file directories");
    }
  fclose(f);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,i);
  f=fopen(fn,"wb");
  if (f==NULL)
    {
      fprintf(stderr,"I cannot create PipBase file %s\n",fn); 
      esci("Please check file directories");
    }
  fputc(0,f); 
  fputc(0,f); 
  fclose(f);
  printf("Created area#%d: %s\n",i,descr);
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir); /* sets to 0 lastread pointers */
  f=fopen(fn,"rb+");
  nu=filelength(fileno(f))/(cfg.pipsize*sizeof(uint));
  j=0; 
  for(lr=0; lr!=nu; lr++)
    {
      fseek(f,(lr*cfg.pipsize+i)*sizeof(uint),SEEK_SET);
      fwrite(&j,sizeof(uint),1,f);
    }
  fclose(f);
}


rebuild_destptr(int quiet)
{
  unsigned int i,j;
  FILE *fi,*fp;
  DESTPTR dest;
  MSGPTR p;
  sprintf(fn,"%sDestPtr.Pip",cfg.pipdir); f=fopen(fn,"wb");
  if (!quiet) printf("Rebuilding %s...",fn);
  for(i=0; i!=cfg.pipsize; i++)
    if (*areas[i].descr)
      {
        if (!quiet) printf("\nArea #%d, message#",i);
        sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,i); fp=fopen(fn,"rb");
        sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,i); fi=fopen(fn,"rb");
        j=0;
        while (fread(&p,sizeof(p),1,fp))
          {
            if (!quiet) printf("%05d\b\b\b\b\b",j);
            if (!(p.status&1) && !(p.status&2))
              {
                if (fseek(fi,p.pos+14,SEEK_SET)==0)
                  {
                    read0(dest.to,fi,36,1); read0(dest.to,fi,36,1);
                    dest.msg=j; dest.area=i;
                    fwrite(&dest,sizeof(dest),1,f);
                  }
              }
            j++;
          }
        fclose(fi); fclose(fp);
      }
  if (fclose(f)) esci("\nErrors in writing DestPtr.Pip"); else printf("\nOK\n");
}


destroy_area(int i)
{
  if ((i<0) || (i>=cfg.pipsize)) {fprintf(stderr,"%d is not a valid area number",i); esci("");}
  if (*areas[i].descr==0) esci("You cannot destroy a never created area");
  *areas[i].descr=*areas[i].tag=0; write_areas();
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,i); unlink(fn);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,i); unlink(fn);
  rebuild_destptr(0);
  printf("Area #%d destroyed\n",i);
}


msg_delete(unsigned int area,unsigned int msg)
{
  MSGPTR hdr;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status|=1; /* bit deleted */
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); printf("message %d in area %d deleted\n",msg,area);
}


msg_undelete(unsigned int area,unsigned int msg)
{
  MSGPTR hdr;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status&=254; /* bit deleted set to off*/
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); printf("message %d in area %d undeleted\n",msg,area);
}


msg_mark(unsigned int area,unsigned int msg,int quiet)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status|=2; /* bit received*/
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); if(!quiet) printf("message %d in area %d marked as received\n",msg,area);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute|=4;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


msg_unmark(unsigned int area,unsigned int msg)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status&=253; /* bit received set to off*/
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); printf("message %d in area %d marked as not received\n",msg,area);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute&=0xfffb;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


msg_setflag(uint area,uint msg,uint flag)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0))
    {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  fclose(f);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute|=flag;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


msg_resetflag(uint area,uint msg,uint flag)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0))
    {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  fclose(f);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute&=~flag;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


msg_lock(unsigned int area,unsigned int msg)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status|=SET_MPTR_LOCK;
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); printf("message %d in area %d locked: undeletable\n",msg,area);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute|=SET_PKT_LOCK;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


msg_unlock(unsigned int area,unsigned int msg)
{
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  if (f==NULL) esci("PipBase corrupted!");
  if (fseek(f,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist");
  if (fread(&hdr,sizeof(hdr),1,f)==0) esci("I can't find the message");
  hdr.status&=RESET_MPTR_LOCK;
  fseek(f,sizeof(hdr)*msg,SEEK_SET);
  if (fwrite(&hdr,sizeof(hdr),1,f)==0) esci("I can't rewrite the message header");
  fclose(f); printf("message %d in area %d unlocked: now you can delete it\n",msg,area);
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f=fopen(fn,"rb+");
  fseek(f,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f);
  mpkt.attribute&=RESET_PKT_LOCK;
  fseek(f,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f); fclose(f);
}


printheader(uint attrib,uint status,FILE *fo)
{
  if (attrib || status)
    {
      fprintf(fo,"Stat:");
      if (attrib & SET_PKT_PRIV) fprintf(fo,"Priv ");
      if (attrib & SET_PKT_CRASH) fprintf(fo,"Crash ");
      if (attrib & SET_PKT_ATTACH) fprintf(fo,"File ");
      if (attrib & SET_PKT_TRANSIT) fprintf(fo,"Trans ");
      if (attrib & SET_PKT_KILL) fprintf(fo,"Kill ");
      if (attrib & SET_PKT_LOCAL) fprintf(fo,"Local ");
      if (attrib & SET_PKT_HOLD) fprintf(fo,"Hold ");
      if (attrib & SET_PKT_REQUEST) fprintf(fo,"FRq ");
      if (attrib & SET_PKT_RRRQ) fprintf(fo,"RR.Rq. ");
      if (attrib & SET_PKT_ISRR) fprintf(fo,"IsRR. ");
      if (attrib & SET_PKT_AUDIT) fprintf(fo,"Audit ");
      if (attrib & SET_PKT_UPDATE) fprintf(fo,"UpdRq. ");
      if (status & SET_MPTR_DEL) fprintf(fo,"Deleted ");
      if (status & SET_MPTR_RCVD) fprintf(fo,"Rcvd ");
      if (status & SET_MPTR_SENT) fprintf(fo,"Sent ");
      if (status & SET_MPTR_LOCK) fprintf(fo,"Lock ");
      fprintf(fo,"\n");
    }
}


printreplychain(uint prev,uint next)
{
  if(prev || next)
    {
      if(prev)
        {
          if(next)
            printf("Reply: %d <- -> %d\n",prev,next);
          else
            printf("Relpy: %d <-\n",prev);
        }
      else
        printf("Reply: -> %d\n",next);
    }
}


msg_read(unsigned int area,unsigned int msg,char mark)
{
  FILE *f1,*f2;
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  char date[20],from[36],to[36],subj[72],*buff;
  if ((area<0) || (area>=cfg.pipsize) || (*areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=fopen(fn,"rb+");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f2=fopen(fn,"rb+");
  if ((f1==NULL) || (f2==NULL)) esci("PipBase corrupted!");
  if (fseek(f1,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist!");
  if (fread(&hdr,sizeof(hdr),1,f1)==0) esci("I can't find the message");
  if (!(mark&SET_NEW) || !((hdr.status&SET_MPTR_RCVD) || (hdr.status&SET_MPTR_DEL)))
    {
      printf("Message position=%ld\n",hdr.pos);
      fseek(f2,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f2);
      if ((buff=(char *)malloc(BUFSIZE))==NULL) esci("Not enought memory");
      read0(date,f2,20,1);
      read0(to,f2,36,1);
      read0(from,f2,36,1);
      read0(subj,f2,72,1);
      read0(buff,f2,BUFSIZE-100,1);
      printf("Area#%d, message#%d\nFrom:%s (%d/%d.%d)\nTo  :%s (%d/%d.%d)\nSubj:%s\nDate:%s\n",area,msg,from,mpkt.fromnet,mpkt.fromnode,(mpkt.attribute&SET_PKT_LOCAL)?cfg.address[areas[area].address].point:mpkt.point,to,mpkt.tonet,mpkt.tonode,(mpkt.attribute&SET_PKT_LOCAL)?mpkt.point:cfg.address[areas[area].address].point,subj,date);
      printheader(mpkt.attribute,hdr.status,stdout);
      printreplychain(hdr.prev,hdr.next);
      printf("\n");
      switch(mpkt.pktype)
        {
          case 2:
            writemex(buff,stdout,1); break;
          case 10:
            unpipstring('\n',buff,stdout); break;
          default:
            esci("unknown compression method");
        }
      free(buff);
      if (mark&(SET_MARK|SET_DEL))
        {
          hdr.status|=(mark&SET_DEL)?SET_MPTR_DEL:SET_MPTR_RCVD; /* bit received/deleted set to on*/
          printf("Marked as %s\n",(mark&SET_DEL)?"deleted":"received");
          fseek(f1,sizeof(hdr)*msg,SEEK_SET);
          if (fwrite(&hdr,sizeof(hdr),1,f1)==0) esci("I can't rewrite the message header");
          mpkt.attribute|=(mark&SET_MARK)?SET_PKT_RCVD:0;
          fseek(f2,hdr.pos,SEEK_SET); fwrite(&mpkt,sizeof(mpkt),1,f2);
        }
    }
  fclose(f1); fclose(f2);
  printf("\n\n");
}


msg_readarea(uint area,char c)
{
  int f1;
  uint nm,i;
  if ((area<0) || (area>=cfg.pipsize) || (*areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=open(fn,O_BINARY);
  nm=filelength(f1)/sizeof(MSGPTR); close(f1);
  for (i=0; i!=nm; i++) msg_read(area,i,c);
}


msg_disphdr(unsigned int area,unsigned int msg,char mark)
{
  FILE *f1,*f2;
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  char date[20],from[36],to[36],subj[72];
  if ((area<0) || (area>=cfg.pipsize) || (*areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=fopen(fn,"rb+");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f2=fopen(fn,"rb+");
  if ((f1==NULL) || (f2==NULL)) esci("PipBase corrupted!");
  if (fseek(f1,sizeof(hdr)*msg,SEEK_SET)) esci("the message dosn't exist!");
  if (fread(&hdr,sizeof(hdr),1,f1)==0) esci("I can't find the message");
  if (!(mark&SET_NEW) || !(hdr.status&SET_MPTR_RCVD))
    {
      printf("Message position=%ld\n",hdr.pos);
      fseek(f2,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f2);
      read0(date,f2,20,1);
      read0(to,f2,36,1);
      read0(from,f2,36,1);
      read0(subj,f2,72,1);
      printf("Area#%d, message#%d\nFrom:%s (%d/%d.%d)\nTo  :%s (%d/%d.%d)\nSubj:%s\nDate:%s\n",area,msg,from,mpkt.fromnet,mpkt.fromnode,(mpkt.attribute&SET_PKT_LOCAL)?cfg.address[areas[area].address].point:mpkt.point,to,mpkt.tonet,mpkt.tonode,(mpkt.attribute&SET_PKT_LOCAL)?mpkt.point:cfg.address[areas[area].address].point,subj,date);
      printheader(mpkt.attribute,hdr.status,stdout);
      printreplychain(hdr.prev,hdr.next);
      printf("\n");
    }
  fclose(f1); fclose(f2);
}


listarea(uint area,char c)
{
  int f1;
  uint nm,i;
  if ((area<0) || (area>=cfg.pipsize) || (*areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=open(fn,O_BINARY);
  nm=filelength(f1)/sizeof(MSGPTR); close(f1);
  printf("Area #%d (%s) contains %d messages\n\n",area,areas[area].descr,nm);
  for (i=0; i!=nm; i++) msg_disphdr(area,i,c);
}


msg_post(int area,char *file,char *from1,char *to1,char *subj,uint attr,NODEADDR *dest,char *uucp)
{
  FILE *f1,*f2;
  MSGPTR hdr;
  MSGPKTHDR mpkt;
  DESTPTR pt;
  char from[36],to[36],date[20],*buff;
  if ((area<0) || (area>=cfg.pipsize) || (areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=fopen(fn,"rb+");
  if (f1==NULL) f1=fopen(fn,"wb");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f2=fopen(fn,"rb+");
  if (f2==NULL) f2=fopen(fn,"wb");
  if ((buff=(char *)malloc(BUFSIZE))==NULL) esci("Not enought memory");
  readfile(buff,file);
  if (isdigit(*from1)) strcpy(from,cfg.usernames[*from1-'0']); else strcpy(from,from1);
  if (isdigit(*to1)) strcpy(to,cfg.usernames[*to1-'0']); else strcpy(to,to1);
  mpkt.fromnode=cfg.address[areas[area].address].node;
  mpkt.fromnet=cfg.address[areas[area].address].net;
  mpkt.pktype=10 /*2*/ ;
  mpkt.attribute=attr|SET_PKT_LOCAL; /* from us */
  if (!stricmp(areas[area].tag,"#NETMAIL"))
    {
      if(*uucp)
        {
          dest->zone=cfg.uucp_out_zone;
          dest->net=cfg.uucp_out_net;
          dest->node=cfg.uucp_out_node;
          dest->point=0;
          strcpy(to,"UUCP");
        }
      mpkt.tonode=dest->node;
      mpkt.tonet=dest->net;
      mpkt.point=dest->point;
    }
  else
    {
      mpkt.tonode=0;
      mpkt.tonet=0;
      mpkt.point=0;
    }
  fseek(f2,filelength(fileno(f2))-2,SEEK_SET); hdr.pos=ftell(f2);
  hdr.next=hdr.prev=0;
  hdr.status=SET_MPTR_FROMUS; /* from us */
  fseek(f1,filelength(fileno(f1)),SEEK_SET);
  pt.area=area; pt.msg=ftell(f1)/sizeof(hdr); strcpy(pt.to,to);
  pt.next=0;
  printf("Saving %s as message #%d\n",file,ftell(f1)/sizeof(hdr));
  fwrite(&hdr,sizeof hdr,1,f1);
  fwrite(&mpkt,sizeof mpkt,1,f2);
  getdate(&dt); gettime(&tm);
  sprintf(date,"%02d %3s %02d  %02d:%02d:%02d",dt.da_day,mname[dt.da_mon-1],dt.da_year%100,tm.ti_hour,tm.ti_min,tm.ti_sec);
  write0(date,f2);
  write0(to,f2);
  write0(from,f2);
  write0(subj,f2);
  if (!stricmp(areas[area].tag,"#NETMAIL"))
    {
      if(dest->zone!=cfg.address[areas[area].address].zone)
        fprintf(f2,"\1INTL %d:%d/%d %d:%d/%d\r",dest->zone,dest->net,dest->node,cfg.address[areas[area].address].zone,cfg.address[areas[area].address].net,cfg.address[areas[area].address].node);
      if(dest->point)
        fprintf(f2,"\1TOPT %d\r",dest->point);
      if(cfg.address[areas[area].address].point)
        fprintf(f2,"\1FMPT %d\r",cfg.address[areas[area].address].point);
    }
  if (*areas[area].tag!='#') /* echomail area */
    {
      sprintf(lbuff,"/%d",registered);
      sprintf(fn,"--- PipBase %d.%02d%s%s%s\r",PIPBASEVERSION,PIPBASESUBVERSION,registered?lbuff:"/demo",*cfg.addtear?" ":"",cfg.addtear);
      strcat(buff,fn);
      sprintf(fn," * Origin: %s (%d:%d/%d.%d",origins[areas[area].origin],
        cfg.address[areas[area].address].zone,
        cfg.address[areas[area].address].net,
        cfg.address[areas[area].address].node,
        cfg.address[areas[area].address].point);
      strcat(buff,fn);
      if (strlen(fn)+strlen(cfg.address[areas[area].address].domain)<77)
        sprintf(fn,"@%s)\r",cfg.address[areas[area].address].domain);
      else
        sprintf(fn,")\r");
      if(strlen(fn)>79)
        sprintf(fn," * Origin: Original origin line too long! (%d:%d/%d.%d)\r",
                cfg.address[areas[area].address].zone,
                cfg.address[areas[area].address].net,
                cfg.address[areas[area].address].node,
                cfg.address[areas[area].address].point);
      strcat(buff,fn);
    }
  if(*uucp)
    fprintf(f2,"To: %s\r\n\r",uucp);
  pipstring(buff,f2);
  /* write0(buff,f2); */
  fputc(0,f2); fputc(0,f2);
  fclose(f1); fclose(f2);
  sprintf(fn,"%sDestPtr.Pip",cfg.pipdir,area); f=fopen(fn,"ab+");
  fwrite(&pt,sizeof pt,1,f);
  fclose(f);
  free(buff);
}


scanx(uint user,char *area)
{
  char *u;
  long nm=0;
  DESTPTR pt;
  if ((user<0)||(user>7)) esci("It's not a valid user number");
  sprintf(fn,"%sDestPtr.Pip",cfg.pipdir);
  f=fopen(fn,"rb");
  u=cfg.usernames[user];
  printf("Searching messages for %s...\n",u);
  while (fread(&pt,sizeof pt,1,f))
    if(!stricmp(pt.to,u))
      {
        if (area)
          {if (pt.area==atoi(area)) msg_read(pt.area,pt.msg,SET_NEW); nm++;}
        else
          {msg_read(pt.area,pt.msg,SET_NEW); nm++;}
      }
  fclose(f);
  printf("%d message(s) found\n",nm);
}


movearea(uint old,uint new)
{
  AREASTRUCT tmp;
  char fn1[80],fn2[80];
  uint lr,i,j,nu;
  if (!*areas[old].descr)
    esci("You cannot move an unexisting area!");
  if (*areas[new].descr)
    esci("You cannot move an area over another!");
  memcpy(&tmp,&areas[new],sizeof(AREASTRUCT));
  memcpy(&areas[new],&areas[old],sizeof(AREASTRUCT));
  memcpy(&areas[old],&tmp,sizeof(AREASTRUCT));
  sprintf(fn1,"%sMPTR%04x.PIP",cfg.pipdir,old);
  sprintf(fn2,"%sMPTR%04x.PIP",cfg.pipdir,new);
  unlink(fn2);
  rename(fn1,fn2);
  sprintf(fn1,"%sMPKT%04x.PIP",cfg.pipdir,old);
  sprintf(fn2,"%sMPKT%04x.PIP",cfg.pipdir,new);
  unlink(fn2);
  rename(fn1,fn2);
  write_areas();
  puts("Rebuilding indexes");
  rebuild_destptr(1);
  printf("Area#%d moved into %d\n",old,new);
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir); /* swaps lastread pointers */
  f=fopen(fn,"rb+");
  nu=filelength(fileno(f))/(cfg.pipsize*sizeof(uint));
  for(lr=0; lr!=nu; lr++)
    {
      fseek(f,(lr*cfg.pipsize+old)*sizeof(uint),SEEK_SET);
      fread(&j,sizeof(uint),1,f);
      fseek(f,(lr*cfg.pipsize+new)*sizeof(uint),SEEK_SET);
      fread(&i,sizeof(uint),1,f);
      fseek(f,(lr*cfg.pipsize+new)*sizeof(uint),SEEK_SET);
      fwrite(&j,sizeof(uint),1,f);
      fseek(f,(lr*cfg.pipsize+old)*sizeof(uint),SEEK_SET);
      fwrite(&i,sizeof(uint),1,f);
    }
  fclose(f);
}


char *str(int n) /* converts an integer into a string */
{
  char r[10];
  sprintf(r,"%d",n);
  return r;
}


setlastread(uint user,uint area,uint msg,char quiet)
{
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir);
  if ((area<0) || (area>=cfg.pipsize)) 
    {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  f=fopen(fn,"rb+");
  fseek(f,(user*cfg.pipsize+area)*sizeof(msg),SEEK_SET);
  fwrite(&msg,sizeof msg,1,f);
  fclose(f);
  sprintf(lbuff,"Lastread for %s is set to %d/%d",(user<8)?cfg.usernames[user]:str(user),area,msg);
  if(!quiet)
    printf("%s\n",lbuff); 
  logg(' ',lbuff,3);
}


showlastread(uint user,uint area)
{
  uint msg;
  if ((area<0) || (area>=cfg.pipsize))
    {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sLastRead.Pip",cfg.pipdir);
  f=fopen(fn,"rb");
  fseek(f,(user*cfg.pipsize+area)*sizeof(msg),SEEK_SET);
  fread(&msg,sizeof msg,1,f);
  fclose(f);
  sprintf(lbuff,"Lastread for %s is set to %d/%d",(user<8)?cfg.usernames[user]:str(user),area,msg);
  printf("%s\n",lbuff); 
  logg(' ',lbuff,3);
}


uint number_of_messages(uint i) /* returns the number of messages contained in area i */
{
  char fn[80];
  FILE *f;
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,i); f=fopen(fn,"rb");
  i=filelength(fileno(f))/sizeof(MSGPTR);
  fclose(f);
  return i;
}


parse_uucp(char *buff,char *id,char *in,char *uucp)
{
  char *z,*z2;
  z=strstr(buff,in);
  if(z)
    {
      z+=strlen(in); z2=uucp;
      while(*z>32)
        *(z2++)=*(z++);
      *z2=0; z2=id;
      while(*z && *z!=10 && *z!=13 && *z!='(')
        z++;
      if(*z=='(')
        {
          z++;
          while(*z && *z!=10 && *z!=13 && *z!=')')
            *(z2++)=*(z++);
          *z2=0;
        }
      return 0;
    }
  return 1;
}


msg_load(uint area,uint msg,char *date,char *from,char *to,char *subj,char *buff,NODEADDR *fromaddr,NODEADDR *destaddr,uint *attr,uint *status,uint *prev,uint *next,char *fromuucp,char *touucp)
/* loads a message into memory and returns message flags */
{
  FILE *f1,*f2;
  char *z,*z2;
  MSGPKTHDR mpkt;
  MSGPTR hdr;
  *fromuucp=*touucp=0;
  if ((area<0) || (area>=cfg.pipsize) || (*areas[area].descr==0)) {fprintf(stderr,"%d is not a valid area number",area); esci("");}
  sprintf(fn,"%sMPTR%04x.PIP",cfg.pipdir,area); f1=fopen(fn,"rb+");
  sprintf(fn,"%sMPKT%04x.PIP",cfg.pipdir,area); f2=fopen(fn,"rb+");
  if ((f1==NULL) || (f2==NULL)) esci("PipBase corrupted!");
  if (fseek(f1,sizeof(hdr)*msg,SEEK_SET)) esci("the message doesn't exist!");
  if (fread(&hdr,sizeof(hdr),1,f1)==0) esci("I can't find the message");
  fseek(f2,hdr.pos,SEEK_SET); fread(&mpkt,sizeof(mpkt),1,f2);
  read0(date,f2,20,1);
  read0(to,f2,36,1); 
  read0(from,f2,36,1);
  read0(subj,f2,72,1);
  *status=hdr.status; *attr=mpkt.attribute;
  switch(mpkt.pktype)
    {
      case 2:
        read0(buff,f2,BUFSIZE-100,1);
        break;
      case 10:
        unpipfile(buff,f2);
        break;
      default:
        esci("unknown compression method");
    }
  fclose(f1); fclose(f2);
  if(*areas[area].tag=='#')
    {
      if(stricmp(areas[area].tag,"#NETMAIL"))
        {
          memcpy(fromaddr,&cfg.address[0],sizeof(NODEADDR));
          memcpy(destaddr,&cfg.address[0],sizeof(NODEADDR));
        }
      else
        {
          fromaddr->net=mpkt.fromnet; 
          fromaddr->node=mpkt.fromnode;
          destaddr->net=mpkt.tonet;
          destaddr->node=mpkt.tonode;
          if((z=strstr(buff,"\1TOPT "))!=NULL)
            destaddr->point=atoi(z+6); 
          else 
            destaddr->point=0;
          if((z=strstr(buff,"\1FMPT "))!=NULL)
            fromaddr->point=atoi(z+6); 
          else 
            fromaddr->point=0;
          if((z=strstr(buff,"\1INTL "))!=NULL)
            {
              fromaddr->zone=atoi(strstr(z+6," ")+1); 
              destaddr->zone=atoi(z+6);
            }
          else 
            fromaddr->zone=destaddr->zone=cfg.address[areas[area].address].zone;
          if(!stricmp(from,"UUCP"))
            parse_uucp(buff,from,"From: ",fromuucp);
          if(!stricmp(to,"UUCP"))
            parse_uucp(buff,to,"To: ",touucp);
        }
    }
  else
    {
      memcpy(destaddr,&cfg.address[0],sizeof(NODEADDR));
      if((z=strchr(buff,'('))==NULL)
        memcpy(fromaddr,&cfg.address[0],sizeof(NODEADDR));
      else
        {
          while((z2=strchr(z,'('))!=NULL)
            z=z2+1;
          z2=z;
          while(!isdigit(*z) && (*z!='@')) z++; 
          if(isdigit(*z))
            {
              fromaddr->zone=atoi(z);
              z=strchr(z,':')+1; fromaddr->net=atoi(z);
              z=strchr(z,'/')+1; fromaddr->node=atoi(z);
              if(strchr(z,'.')<strchr(z,')')) 
                {z=strchr(z,'.')+1; fromaddr->point=atoi(z);}
              else
                fromaddr->point=0;
              if((z=strchr(z,'@'))!=NULL)
                {
                  z++; z2=fromaddr->domain;
                  while(*z!=')') *(z2++)=*(z++);
                  *z2=0;
                }
              else
                *(fromaddr->domain)=0;
            }
          else
            {
              strcpy(fromaddr->domain,"UUCP");
              fromaddr->zone=cfg.uucp_in_zone;
              fromaddr->net=cfg.uucp_in_net;
              fromaddr->node=cfg.uucp_in_node;
              fromaddr->point=0;
              z=fromuucp;
              while(*z2!=')') *(z++)=*(z2++);
              *z=0;
            }
        }
    }
  *prev=hdr.prev; *next=hdr.next;
  return *attr;
}

